# coding: utf-8

# flake8: noqa
"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

# import models into model package
from redrover_api.models.absence_detail_create_request import AbsenceDetailCreateRequest
from redrover_api.models.absence_detail_response import AbsenceDetailResponse
from redrover_api.models.absence_reason_balance_create_request import AbsenceReasonBalanceCreateRequest
from redrover_api.models.absence_reason_balance_response import AbsenceReasonBalanceResponse
from redrover_api.models.absence_reason_balance_update_request import AbsenceReasonBalanceUpdateRequest
from redrover_api.models.absence_reason_category_response import AbsenceReasonCategoryResponse
from redrover_api.models.absence_reason_response import AbsenceReasonResponse
from redrover_api.models.absence_reason_usage_create_request import AbsenceReasonUsageCreateRequest
from redrover_api.models.absence_reason_usage_response import AbsenceReasonUsageResponse
from redrover_api.models.absence_request import AbsenceRequest
from redrover_api.models.absence_response import AbsenceResponse
from redrover_api.models.access_control_request import AccessControlRequest
from redrover_api.models.access_control_response import AccessControlResponse
from redrover_api.models.accounting_code import AccountingCode
from redrover_api.models.accounting_code_allocation import AccountingCodeAllocation
from redrover_api.models.accounting_code_allocation_request import AccountingCodeAllocationRequest
from redrover_api.models.administrator_request import AdministratorRequest
from redrover_api.models.administrator_response import AdministratorResponse
from redrover_api.models.assembly import Assembly
from redrover_api.models.attribute_request import AttributeRequest
from redrover_api.models.attribute_response import AttributeResponse
from redrover_api.models.authentication_properties import AuthenticationProperties
from redrover_api.models.bad_request_result import BadRequestResult
from redrover_api.models.constructor_info import ConstructorInfo
from redrover_api.models.custom_attribute_data import CustomAttributeData
from redrover_api.models.custom_attribute_named_argument import CustomAttributeNamedArgument
from redrover_api.models.custom_attribute_typed_argument import CustomAttributeTypedArgument
from redrover_api.models.employee_request import EmployeeRequest
from redrover_api.models.employee_response import EmployeeResponse
from redrover_api.models.event_info import EventInfo
from redrover_api.models.field_info import FieldInfo
from redrover_api.models.forbid_result import ForbidResult
from redrover_api.models.int32_locator_request import Int32LocatorRequest
from redrover_api.models.int32_locator_response import Int32LocatorResponse
from redrover_api.models.member_info import MemberInfo
from redrover_api.models.method_base import MethodBase
from redrover_api.models.method_info import MethodInfo
from redrover_api.models.module import Module
from redrover_api.models.module_handle import ModuleHandle
from redrover_api.models.not_found_result import NotFoundResult
from redrover_api.models.ok_object_result import OkObjectResult
from redrover_api.models.ok_result import OkResult
from redrover_api.models.org_user_employee_response import OrgUserEmployeeResponse
from redrover_api.models.organization_response import OrganizationResponse
from redrover_api.models.parameter_info import ParameterInfo
from redrover_api.models.pay_code import PayCode
from redrover_api.models.position_job_request import PositionJobRequest
from redrover_api.models.position_request import PositionRequest
from redrover_api.models.position_schedule_custom_variant_request import PositionScheduleCustomVariantRequest
from redrover_api.models.position_schedule_item_request import PositionScheduleItemRequest
from redrover_api.models.position_schedule_request import PositionScheduleRequest
from redrover_api.models.problem_details import ProblemDetails
from redrover_api.models.property_info import PropertyInfo
from redrover_api.models.reason import Reason
from redrover_api.models.runtime_field_handle import RuntimeFieldHandle
from redrover_api.models.runtime_method_handle import RuntimeMethodHandle
from redrover_api.models.runtime_type_handle import RuntimeTypeHandle
from redrover_api.models.school_year_response import SchoolYearResponse
from redrover_api.models.simple_absence_detail import SimpleAbsenceDetail
from redrover_api.models.simple_location import SimpleLocation
from redrover_api.models.simple_person import SimplePerson
from redrover_api.models.simple_position import SimplePosition
from redrover_api.models.struct_layout_attribute import StructLayoutAttribute
from redrover_api.models.substitute_attribute_request import SubstituteAttributeRequest
from redrover_api.models.substitute_attribute_response import SubstituteAttributeResponse
from redrover_api.models.substitute_preferences_request import SubstitutePreferencesRequest
from redrover_api.models.substitute_related_org_request import SubstituteRelatedOrgRequest
from redrover_api.models.substitute_request import SubstituteRequest
from redrover_api.models.substitute_response import SubstituteResponse
from redrover_api.models.time_off_balance_request import TimeOffBalanceRequest
from redrover_api.models.time_span import TimeSpan
from redrover_api.models.type import Type
from redrover_api.models.type_info import TypeInfo
from redrover_api.models.vacancy_detail_response import VacancyDetailResponse
from redrover_api.models.webhook_create_request import WebhookCreateRequest
from redrover_api.models.webhook_response import WebhookResponse
from redrover_api.models.webhook_update_request import WebhookUpdateRequest
