# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class PositionScheduleRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'items': 'list[PositionScheduleItemRequest]',
        'days_of_the_week': 'list[str]'
    }

    attribute_map = {
        'items': 'items',
        'days_of_the_week': 'daysOfTheWeek'
    }

    def __init__(self, items=None, days_of_the_week=None, local_vars_configuration=None):  # noqa: E501
        """PositionScheduleRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._items = None
        self._days_of_the_week = None
        self.discriminator = None

        self.items = items
        self.days_of_the_week = days_of_the_week

    @property
    def items(self):
        """Gets the items of this PositionScheduleRequest.  # noqa: E501

        Position Schedule Items  # noqa: E501

        :return: The items of this PositionScheduleRequest.  # noqa: E501
        :rtype: list[PositionScheduleItemRequest]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this PositionScheduleRequest.

        Position Schedule Items  # noqa: E501

        :param items: The items of this PositionScheduleRequest.  # noqa: E501
        :type: list[PositionScheduleItemRequest]
        """
        if self.local_vars_configuration.client_side_validation and items is None:  # noqa: E501
            raise ValueError("Invalid value for `items`, must not be `None`")  # noqa: E501

        self._items = items

    @property
    def days_of_the_week(self):
        """Gets the days_of_the_week of this PositionScheduleRequest.  # noqa: E501

        Days of the week  # noqa: E501

        :return: The days_of_the_week of this PositionScheduleRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._days_of_the_week

    @days_of_the_week.setter
    def days_of_the_week(self, days_of_the_week):
        """Sets the days_of_the_week of this PositionScheduleRequest.

        Days of the week  # noqa: E501

        :param days_of_the_week: The days_of_the_week of this PositionScheduleRequest.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and days_of_the_week is None:  # noqa: E501
            raise ValueError("Invalid value for `days_of_the_week`, must not be `None`")  # noqa: E501
        allowed_values = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                not set(days_of_the_week).issubset(set(allowed_values))):  # noqa: E501
            raise ValueError(
                "Invalid values for `days_of_the_week` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(days_of_the_week) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._days_of_the_week = days_of_the_week

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PositionScheduleRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PositionScheduleRequest):
            return True

        return self.to_dict() != other.to_dict()
