# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class SchoolYearResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'start_date': 'datetime',
        'end_date': 'datetime',
        'earliest_date_for_absence_entry': 'datetime',
        'is_current_school_year': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'start_date': 'startDate',
        'end_date': 'endDate',
        'earliest_date_for_absence_entry': 'earliestDateForAbsenceEntry',
        'is_current_school_year': 'isCurrentSchoolYear'
    }

    def __init__(self, id=None, name=None, start_date=None, end_date=None, earliest_date_for_absence_entry=None, is_current_school_year=None, local_vars_configuration=None):  # noqa: E501
        """SchoolYearResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._start_date = None
        self._end_date = None
        self._earliest_date_for_absence_entry = None
        self._is_current_school_year = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        if start_date is not None:
            self.start_date = start_date
        if end_date is not None:
            self.end_date = end_date
        if earliest_date_for_absence_entry is not None:
            self.earliest_date_for_absence_entry = earliest_date_for_absence_entry
        if is_current_school_year is not None:
            self.is_current_school_year = is_current_school_year

    @property
    def id(self):
        """Gets the id of this SchoolYearResponse.  # noqa: E501

        The Red Rover internal Id of SchoolYear (numeric)  # noqa: E501

        :return: The id of this SchoolYearResponse.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SchoolYearResponse.

        The Red Rover internal Id of SchoolYear (numeric)  # noqa: E501

        :param id: The id of this SchoolYearResponse.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this SchoolYearResponse.  # noqa: E501

        The generated name for the School Year  # noqa: E501

        :return: The name of this SchoolYearResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SchoolYearResponse.

        The generated name for the School Year  # noqa: E501

        :param name: The name of this SchoolYearResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def start_date(self):
        """Gets the start_date of this SchoolYearResponse.  # noqa: E501

        The Start Date of the School Year  # noqa: E501

        :return: The start_date of this SchoolYearResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this SchoolYearResponse.

        The Start Date of the School Year  # noqa: E501

        :param start_date: The start_date of this SchoolYearResponse.  # noqa: E501
        :type: datetime
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this SchoolYearResponse.  # noqa: E501

        The End Date of the School Year  # noqa: E501

        :return: The end_date of this SchoolYearResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this SchoolYearResponse.

        The End Date of the School Year  # noqa: E501

        :param end_date: The end_date of this SchoolYearResponse.  # noqa: E501
        :type: datetime
        """

        self._end_date = end_date

    @property
    def earliest_date_for_absence_entry(self):
        """Gets the earliest_date_for_absence_entry of this SchoolYearResponse.  # noqa: E501

        The date in which Absences are allowed to be created  # noqa: E501

        :return: The earliest_date_for_absence_entry of this SchoolYearResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._earliest_date_for_absence_entry

    @earliest_date_for_absence_entry.setter
    def earliest_date_for_absence_entry(self, earliest_date_for_absence_entry):
        """Sets the earliest_date_for_absence_entry of this SchoolYearResponse.

        The date in which Absences are allowed to be created  # noqa: E501

        :param earliest_date_for_absence_entry: The earliest_date_for_absence_entry of this SchoolYearResponse.  # noqa: E501
        :type: datetime
        """

        self._earliest_date_for_absence_entry = earliest_date_for_absence_entry

    @property
    def is_current_school_year(self):
        """Gets the is_current_school_year of this SchoolYearResponse.  # noqa: E501

        Is this the current school year  # noqa: E501

        :return: The is_current_school_year of this SchoolYearResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_current_school_year

    @is_current_school_year.setter
    def is_current_school_year(self, is_current_school_year):
        """Sets the is_current_school_year of this SchoolYearResponse.

        Is this the current school year  # noqa: E501

        :param is_current_school_year: The is_current_school_year of this SchoolYearResponse.  # noqa: E501
        :type: bool
        """

        self._is_current_school_year = is_current_school_year

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SchoolYearResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SchoolYearResponse):
            return True

        return self.to_dict() != other.to_dict()
