# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import redrover_api
from redrover_api.models.position_request import PositionRequest  # noqa: E501
from redrover_api.rest import ApiException

class TestPositionRequest(unittest.TestCase):
    """PositionRequest unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test PositionRequest
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = redrover_api.models.position_request.PositionRequest()  # noqa: E501
        if include_optional :
            return PositionRequest(
                external_id = '0', 
                name = '0', 
                position_schedule_mode_id = 'Normal', 
                contract = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                    id = 56, 
                    external_id = '0', ), 
                position_type = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                    id = 56, 
                    external_id = '0', ), 
                hours_per_full_work_day = 1.337, 
                needs_replacement = 'No', 
                start_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                end_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                is_staff_augmentation = True, 
                fte = 1.337, 
                qualified_for_pto = True, 
                qualified_for_paid_holidays = True, 
                qualified_for_pto_as_of = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                qualified_for_paid_holidays_as_of = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                default_job_pay_override = 1.337, 
                code = '0', 
                schedules = [
                    redrover_api.models.position_schedule_request.PositionScheduleRequest(
                        items = [
                            redrover_api.models.position_schedule_item_request.PositionScheduleItemRequest(
                                accounting_code_allocations = [
                                    redrover_api.models.accounting_code_allocation_request.AccountingCodeAllocationRequest(
                                        accounting_code_id = 56, 
                                        allocation = 1.337, )
                                    ], 
                                location = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                job = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                bell_schedule = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                start_period = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                end_period = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                periods_not_needing_replacement = [
                                    redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                        id = 56, 
                                        external_id = '0', )
                                    ], 
                                standard_custom_schedule_variant = redrover_api.models.position_schedule_custom_variant_request.PositionScheduleCustomVariantRequest(
                                    start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    half_day_morning_end_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    half_day_afternoon_start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    end_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    next_start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    is_work_time = True, 
                                    needs_replacement = True, 
                                    needs_replacement_am = True, 
                                    needs_replacement_pm = True, 
                                    work_day_schedule_variant_type = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                        id = 56, 
                                        external_id = '0', ), ), 
                                additional_custom_schedule_variants = [
                                    redrover_api.models.position_schedule_custom_variant_request.PositionScheduleCustomVariantRequest(
                                        is_work_time = True, 
                                        needs_replacement = True, 
                                        needs_replacement_am = True, 
                                        needs_replacement_pm = True, )
                                    ], )
                            ], 
                        days_of_the_week = [
                            'Sunday'
                            ], )
                    ], 
                replace_existing_position_jobs = True, 
                allowed_location_ids = [
                    redrover_api.models.int32_locator_request.Int32LocatorRequest(
                        id = 56, 
                        external_id = '0', )
                    ], 
                other_jobs = [
                    redrover_api.models.position_job_request.PositionJobRequest(
                        job = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                            id = 56, 
                            external_id = '0', ), 
                        pay_step = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                            id = 56, 
                            external_id = '0', ), 
                        override_pay_rate = 1.337, 
                        visible = True, 
                        position_job_id = 56, 
                        effective_as_of = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        accounting_codes = [
                            redrover_api.models.accounting_code_allocation_request.AccountingCodeAllocationRequest(
                                accounting_code_id = 56, 
                                allocation = 1.337, )
                            ], )
                    ], 
                primary_job = redrover_api.models.position_job_request.PositionJobRequest(
                    job = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                        id = 56, 
                        external_id = '0', ), 
                    pay_step = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                        id = 56, 
                        external_id = '0', ), 
                    override_pay_rate = 1.337, 
                    visible = True, 
                    position_job_id = 56, 
                    effective_as_of = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    accounting_codes = [
                        redrover_api.models.accounting_code_allocation_request.AccountingCodeAllocationRequest(
                            accounting_code_id = 56, 
                            allocation = 1.337, )
                        ], )
            )
        else :
            return PositionRequest(
                contract = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                    id = 56, 
                    external_id = '0', ),
                position_type = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                    id = 56, 
                    external_id = '0', ),
                schedules = [
                    redrover_api.models.position_schedule_request.PositionScheduleRequest(
                        items = [
                            redrover_api.models.position_schedule_item_request.PositionScheduleItemRequest(
                                accounting_code_allocations = [
                                    redrover_api.models.accounting_code_allocation_request.AccountingCodeAllocationRequest(
                                        accounting_code_id = 56, 
                                        allocation = 1.337, )
                                    ], 
                                location = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                job = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                bell_schedule = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                start_period = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                end_period = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                    id = 56, 
                                    external_id = '0', ), 
                                periods_not_needing_replacement = [
                                    redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                        id = 56, 
                                        external_id = '0', )
                                    ], 
                                standard_custom_schedule_variant = redrover_api.models.position_schedule_custom_variant_request.PositionScheduleCustomVariantRequest(
                                    start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    half_day_morning_end_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    half_day_afternoon_start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    end_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    next_start_time = redrover_api.models.time_span.TimeSpan(
                                        ticks = 56, 
                                        days = 56, 
                                        hours = 56, 
                                        milliseconds = 56, 
                                        minutes = 56, 
                                        seconds = 56, 
                                        total_days = 1.337, 
                                        total_hours = 1.337, 
                                        total_milliseconds = 1.337, 
                                        total_minutes = 1.337, 
                                        total_seconds = 1.337, ), 
                                    is_work_time = True, 
                                    needs_replacement = True, 
                                    needs_replacement_am = True, 
                                    needs_replacement_pm = True, 
                                    work_day_schedule_variant_type = redrover_api.models.int32_locator_request.Int32LocatorRequest(
                                        id = 56, 
                                        external_id = '0', ), ), 
                                additional_custom_schedule_variants = [
                                    redrover_api.models.position_schedule_custom_variant_request.PositionScheduleCustomVariantRequest(
                                        is_work_time = True, 
                                        needs_replacement = True, 
                                        needs_replacement_am = True, 
                                        needs_replacement_pm = True, )
                                    ], )
                            ], 
                        days_of_the_week = [
                            'Sunday'
                            ], )
                    ],
        )

    def testPositionRequest(self):
        """Test PositionRequest"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
