# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import redrover_api
from redrover_api.models.simple_absence_detail import SimpleAbsenceDetail  # noqa: E501
from redrover_api.rest import ApiException

class TestSimpleAbsenceDetail(unittest.TestCase):
    """SimpleAbsenceDetail unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test SimpleAbsenceDetail
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = redrover_api.models.simple_absence_detail.SimpleAbsenceDetail()  # noqa: E501
        if include_optional :
            return SimpleAbsenceDetail(
                absence_id = 56, 
                absence_detail_id = 56, 
                employee = redrover_api.models.simple_person.SimplePerson(
                    id = 56, 
                    external_id = '0', 
                    first_name = '0', 
                    middle_name = '0', 
                    last_name = '0', 
                    source_organization_id = 56, ), 
                start = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                end = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                reasons = [
                    redrover_api.models.reason.Reason(
                        vacancy_reason_id = 56, 
                        absence_reason_id = 56, 
                        external_id = '0', 
                        name = '0', )
                    ]
            )
        else :
            return SimpleAbsenceDetail(
        )

    def testSimpleAbsenceDetail(self):
        """Test SimpleAbsenceDetail"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
