# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import redrover_api
from redrover_api.models.method_info import MethodInfo  # noqa: E501
from redrover_api.rest import ApiException

class TestMethodInfo(unittest.TestCase):
    """MethodInfo unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test MethodInfo
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = redrover_api.models.method_info.MethodInfo()  # noqa: E501
        if include_optional :
            return MethodInfo(
                name = '0', 
                declaring_type = redrover_api.models.type.Type(
                    name = '0', 
                    custom_attributes = [
                        redrover_api.models.custom_attribute_data.CustomAttributeData(
                            attribute_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                assembly = redrover_api.models.assembly.Assembly(
                                    defined_types = [
                                        redrover_api.models.type_info.TypeInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            module = redrover_api.models.module.Module(
                                                fully_qualified_name = '0', 
                                                name = '0', 
                                                md_stream_version = 56, 
                                                module_version_id = '0', 
                                                scope_name = '0', 
                                                module_handle = redrover_api.models.module_handle.ModuleHandle(
                                                    md_stream_version = 56, ), 
                                                metadata_token = 56, ), 
                                            is_nested = True, 
                                            declaring_method = redrover_api.models.method_base.MethodBase(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                reflected_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    underlying_system_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_type_arguments = [
                                                            redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                    type_id = null, 
                                                                    value = 'Sequential', ), 
                                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    attributes = 'ReuseSlot', 
                                                                    method_implementation_flags = 'Managed', 
                                                                    calling_convention = 'Standard', 
                                                                    is_abstract = True, 
                                                                    is_constructor = True, 
                                                                    is_final = True, 
                                                                    is_hide_by_sig = True, 
                                                                    is_special_name = True, 
                                                                    is_static = True, 
                                                                    is_virtual = True, 
                                                                    is_assembly = True, 
                                                                    is_family = True, 
                                                                    is_family_and_assembly = True, 
                                                                    is_family_or_assembly = True, 
                                                                    is_private = True, 
                                                                    is_public = True, 
                                                                    is_constructed_generic_method = True, 
                                                                    is_generic_method = True, 
                                                                    is_generic_method_definition = True, 
                                                                    contains_generic_parameters = True, 
                                                                    method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                                        value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    member_type = 'Constructor', ), 
                                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                guid = '0', 
                                                                base_type = redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, ), 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, )
                                                            ], 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                            type_id = null, ), 
                                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', ), 
                                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                        guid = '0', 
                                                        base_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_type_arguments = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                        type_id = null, ), 
                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', ), 
                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                    guid = '0', 
                                                    base_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(), 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, ), 
                                            reflected_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            underlying_system_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_type_arguments = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                type_id = null, ), 
                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', ), 
                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                            guid = '0', 
                                            base_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, 
                                            generic_type_parameters = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            declared_constructors = [
                                                redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', )
                                                ], 
                                            declared_events = [
                                                redrover_api.models.event_info.EventInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    add_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                                                            attributes = 'None', 
                                                            member = redrover_api.models.member_info.MemberInfo(
                                                                member_type = 'Constructor', 
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, ), 
                                                            name = '0', 
                                                            parameter_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            position = 56, 
                                                            is_in = True, 
                                                            is_lcid = True, 
                                                            is_optional = True, 
                                                            is_out = True, 
                                                            is_retval = True, 
                                                            default_value = null, 
                                                            raw_default_value = null, 
                                                            has_default_value = True, 
                                                            metadata_token = 56, ), 
                                                        return_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    remove_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    raise_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    is_multicast = True, 
                                                    event_handler_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), )
                                                ], 
                                            declared_fields = [
                                                redrover_api.models.field_info.FieldInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'PrivateScope', 
                                                    field_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_init_only = True, 
                                                    is_literal = True, 
                                                    is_not_serialized = True, 
                                                    is_pinvoke_impl = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                                ], 
                                            declared_members = [
                                                redrover_api.models.member_info.MemberInfo(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, )
                                                ], 
                                            declared_methods = [
                                                redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                                ], 
                                            declared_nested_types = [
                                                redrover_api.models.type_info.TypeInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, 
                                                    declared_properties = [
                                                        redrover_api.models.property_info.PropertyInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            property_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            attributes = 'None', 
                                                            is_special_name = True, 
                                                            can_read = True, 
                                                            can_write = True, 
                                                            get_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            set_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                                        ], 
                                                    implemented_interfaces = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], )
                                                ], 
                                            declared_properties = [
                                                redrover_api.models.property_info.PropertyInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    can_read = True, 
                                                    can_write = True, )
                                                ], 
                                            implemented_interfaces = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], )
                                        ], 
                                    exported_types = [
                                        redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, )
                                        ], 
                                    code_base = '0', 
                                    entry_point = redrover_api.models.method_info.MethodInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', 
                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                    full_name = '0', 
                                    image_runtime_version = '0', 
                                    is_dynamic = True, 
                                    location = '0', 
                                    reflection_only = True, 
                                    is_collectible = True, 
                                    is_fully_trusted = True, 
                                    escaped_code_base = '0', 
                                    manifest_module = redrover_api.models.module.Module(
                                        fully_qualified_name = '0', 
                                        name = '0', 
                                        md_stream_version = 56, 
                                        module_version_id = '0', 
                                        scope_name = '0', 
                                        metadata_token = 56, ), 
                                    modules = [
                                        redrover_api.models.module.Module(
                                            fully_qualified_name = '0', 
                                            name = '0', 
                                            md_stream_version = 56, 
                                            module_version_id = '0', 
                                            scope_name = '0', 
                                            metadata_token = 56, )
                                        ], 
                                    global_assembly_cache = True, 
                                    host_context = 56, 
                                    security_rule_set = 'None', ), 
                                module = redrover_api.models.module.Module(
                                    fully_qualified_name = '0', 
                                    name = '0', 
                                    md_stream_version = 56, 
                                    module_version_id = '0', 
                                    scope_name = '0', 
                                    metadata_token = 56, ), 
                                is_nested = True, 
                                declaring_method = redrover_api.models.method_base.MethodBase(
                                    member_type = 'Constructor', 
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, ), 
                                reflected_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                underlying_system_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_type_arguments = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                    type_id = null, ), 
                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    member_type = 'Constructor', ), 
                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                guid = '0', 
                                base_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            constructor = redrover_api.models.constructor_info.ConstructorInfo(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                member_type = 'Constructor', ), 
                            constructor_arguments = [
                                redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                    argument_type = redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, ), )
                                ], 
                            named_arguments = [
                                redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                    member_info = redrover_api.models.member_info.MemberInfo(
                                        member_type = 'Constructor', 
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, ), 
                                    typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                    member_name = '0', 
                                    is_field = True, )
                                ], )
                        ], 
                    is_collectible = True, 
                    metadata_token = 56, 
                    is_interface = True, 
                    member_type = 'Constructor', 
                    namespace = '0', 
                    assembly_qualified_name = '0', 
                    full_name = '0', 
                    assembly = redrover_api.models.assembly.Assembly(
                        code_base = '0', 
                        full_name = '0', 
                        image_runtime_version = '0', 
                        is_dynamic = True, 
                        location = '0', 
                        reflection_only = True, 
                        is_collectible = True, 
                        is_fully_trusted = True, 
                        escaped_code_base = '0', 
                        global_assembly_cache = True, 
                        host_context = 56, 
                        security_rule_set = 'None', ), 
                    module = redrover_api.models.module.Module(
                        fully_qualified_name = '0', 
                        name = '0', 
                        md_stream_version = 56, 
                        module_version_id = '0', 
                        scope_name = '0', 
                        metadata_token = 56, ), 
                    is_nested = True, 
                    declaring_method = redrover_api.models.method_base.MethodBase(
                        member_type = 'Constructor', 
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, ), 
                    reflected_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    underlying_system_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_type_definition = True, 
                    is_array = True, 
                    is_by_ref = True, 
                    is_pointer = True, 
                    is_constructed_generic_type = True, 
                    is_generic_parameter = True, 
                    is_generic_type_parameter = True, 
                    is_generic_method_parameter = True, 
                    is_generic_type = True, 
                    is_generic_type_definition = True, 
                    is_sz_array = True, 
                    is_variable_bound_array = True, 
                    is_by_ref_like = True, 
                    has_element_type = True, 
                    generic_type_arguments = [
                        redrover_api.models.type.Type(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            is_nested = True, 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            guid = '0', 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, )
                        ], 
                    generic_parameter_position = 56, 
                    generic_parameter_attributes = 'None', 
                    attributes = 'NotPublic', 
                    is_abstract = True, 
                    is_import = True, 
                    is_sealed = True, 
                    is_special_name = True, 
                    is_class = True, 
                    is_nested_assembly = True, 
                    is_nested_fam_and_assem = True, 
                    is_nested_family = True, 
                    is_nested_fam_or_assem = True, 
                    is_nested_private = True, 
                    is_nested_public = True, 
                    is_not_public = True, 
                    is_public = True, 
                    is_auto_layout = True, 
                    is_explicit_layout = True, 
                    is_layout_sequential = True, 
                    is_ansi_class = True, 
                    is_auto_class = True, 
                    is_unicode_class = True, 
                    is_com_object = True, 
                    is_contextful = True, 
                    is_enum = True, 
                    is_marshal_by_ref = True, 
                    is_primitive = True, 
                    is_value_type = True, 
                    is_signature_type = True, 
                    is_security_critical = True, 
                    is_security_safe_critical = True, 
                    is_security_transparent = True, 
                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                        type_id = null, ), 
                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        member_type = 'Constructor', ), 
                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                    guid = '0', 
                    base_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_serializable = True, 
                    contains_generic_parameters = True, 
                    is_visible = True, ), 
                reflected_type = redrover_api.models.type.Type(
                    name = '0', 
                    custom_attributes = [
                        redrover_api.models.custom_attribute_data.CustomAttributeData(
                            attribute_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                assembly = redrover_api.models.assembly.Assembly(
                                    defined_types = [
                                        redrover_api.models.type_info.TypeInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            module = redrover_api.models.module.Module(
                                                fully_qualified_name = '0', 
                                                name = '0', 
                                                md_stream_version = 56, 
                                                module_version_id = '0', 
                                                scope_name = '0', 
                                                module_handle = redrover_api.models.module_handle.ModuleHandle(
                                                    md_stream_version = 56, ), 
                                                metadata_token = 56, ), 
                                            is_nested = True, 
                                            declaring_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                declaring_method = redrover_api.models.method_base.MethodBase(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                        value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, ), 
                                                underlying_system_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_type_arguments = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                type_id = null, ), 
                                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', ), 
                                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                            guid = '0', 
                                                            base_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                        type_id = null, ), 
                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', ), 
                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                    guid = '0', 
                                                    base_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_type_arguments = [
                                                    redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, )
                                                    ], 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                    type_id = null, ), 
                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', ), 
                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                guid = '0', 
                                                base_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            declaring_method = redrover_api.models.method_base.MethodBase(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, ), 
                                            underlying_system_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_type_arguments = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                type_id = null, ), 
                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', ), 
                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                            guid = '0', 
                                            base_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, 
                                            generic_type_parameters = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            declared_constructors = [
                                                redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', )
                                                ], 
                                            declared_events = [
                                                redrover_api.models.event_info.EventInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    add_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                                                            attributes = 'None', 
                                                            member = redrover_api.models.member_info.MemberInfo(
                                                                member_type = 'Constructor', 
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, ), 
                                                            name = '0', 
                                                            parameter_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            position = 56, 
                                                            is_in = True, 
                                                            is_lcid = True, 
                                                            is_optional = True, 
                                                            is_out = True, 
                                                            is_retval = True, 
                                                            default_value = null, 
                                                            raw_default_value = null, 
                                                            has_default_value = True, 
                                                            metadata_token = 56, ), 
                                                        return_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    remove_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    raise_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    is_multicast = True, 
                                                    event_handler_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), )
                                                ], 
                                            declared_fields = [
                                                redrover_api.models.field_info.FieldInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'PrivateScope', 
                                                    field_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_init_only = True, 
                                                    is_literal = True, 
                                                    is_not_serialized = True, 
                                                    is_pinvoke_impl = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                                ], 
                                            declared_members = [
                                                redrover_api.models.member_info.MemberInfo(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, )
                                                ], 
                                            declared_methods = [
                                                redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                                ], 
                                            declared_nested_types = [
                                                redrover_api.models.type_info.TypeInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, 
                                                    declared_properties = [
                                                        redrover_api.models.property_info.PropertyInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            property_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            attributes = 'None', 
                                                            is_special_name = True, 
                                                            can_read = True, 
                                                            can_write = True, 
                                                            get_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            set_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                                        ], 
                                                    implemented_interfaces = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], )
                                                ], 
                                            declared_properties = [
                                                redrover_api.models.property_info.PropertyInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    can_read = True, 
                                                    can_write = True, )
                                                ], 
                                            implemented_interfaces = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], )
                                        ], 
                                    exported_types = [
                                        redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, )
                                        ], 
                                    code_base = '0', 
                                    entry_point = redrover_api.models.method_info.MethodInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', 
                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                    full_name = '0', 
                                    image_runtime_version = '0', 
                                    is_dynamic = True, 
                                    location = '0', 
                                    reflection_only = True, 
                                    is_collectible = True, 
                                    is_fully_trusted = True, 
                                    escaped_code_base = '0', 
                                    manifest_module = redrover_api.models.module.Module(
                                        fully_qualified_name = '0', 
                                        name = '0', 
                                        md_stream_version = 56, 
                                        module_version_id = '0', 
                                        scope_name = '0', 
                                        metadata_token = 56, ), 
                                    modules = [
                                        redrover_api.models.module.Module(
                                            fully_qualified_name = '0', 
                                            name = '0', 
                                            md_stream_version = 56, 
                                            module_version_id = '0', 
                                            scope_name = '0', 
                                            metadata_token = 56, )
                                        ], 
                                    global_assembly_cache = True, 
                                    host_context = 56, 
                                    security_rule_set = 'None', ), 
                                module = redrover_api.models.module.Module(
                                    fully_qualified_name = '0', 
                                    name = '0', 
                                    md_stream_version = 56, 
                                    module_version_id = '0', 
                                    scope_name = '0', 
                                    metadata_token = 56, ), 
                                is_nested = True, 
                                declaring_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                declaring_method = redrover_api.models.method_base.MethodBase(
                                    member_type = 'Constructor', 
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, ), 
                                underlying_system_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_type_arguments = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                    type_id = null, ), 
                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    member_type = 'Constructor', ), 
                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                guid = '0', 
                                base_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            constructor = redrover_api.models.constructor_info.ConstructorInfo(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                member_type = 'Constructor', ), 
                            constructor_arguments = [
                                redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                    argument_type = redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, ), )
                                ], 
                            named_arguments = [
                                redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                    member_info = redrover_api.models.member_info.MemberInfo(
                                        member_type = 'Constructor', 
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, ), 
                                    typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                    member_name = '0', 
                                    is_field = True, )
                                ], )
                        ], 
                    is_collectible = True, 
                    metadata_token = 56, 
                    is_interface = True, 
                    member_type = 'Constructor', 
                    namespace = '0', 
                    assembly_qualified_name = '0', 
                    full_name = '0', 
                    assembly = redrover_api.models.assembly.Assembly(
                        code_base = '0', 
                        full_name = '0', 
                        image_runtime_version = '0', 
                        is_dynamic = True, 
                        location = '0', 
                        reflection_only = True, 
                        is_collectible = True, 
                        is_fully_trusted = True, 
                        escaped_code_base = '0', 
                        global_assembly_cache = True, 
                        host_context = 56, 
                        security_rule_set = 'None', ), 
                    module = redrover_api.models.module.Module(
                        fully_qualified_name = '0', 
                        name = '0', 
                        md_stream_version = 56, 
                        module_version_id = '0', 
                        scope_name = '0', 
                        metadata_token = 56, ), 
                    is_nested = True, 
                    declaring_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    declaring_method = redrover_api.models.method_base.MethodBase(
                        member_type = 'Constructor', 
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, ), 
                    underlying_system_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_type_definition = True, 
                    is_array = True, 
                    is_by_ref = True, 
                    is_pointer = True, 
                    is_constructed_generic_type = True, 
                    is_generic_parameter = True, 
                    is_generic_type_parameter = True, 
                    is_generic_method_parameter = True, 
                    is_generic_type = True, 
                    is_generic_type_definition = True, 
                    is_sz_array = True, 
                    is_variable_bound_array = True, 
                    is_by_ref_like = True, 
                    has_element_type = True, 
                    generic_type_arguments = [
                        redrover_api.models.type.Type(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            is_nested = True, 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            guid = '0', 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, )
                        ], 
                    generic_parameter_position = 56, 
                    generic_parameter_attributes = 'None', 
                    attributes = 'NotPublic', 
                    is_abstract = True, 
                    is_import = True, 
                    is_sealed = True, 
                    is_special_name = True, 
                    is_class = True, 
                    is_nested_assembly = True, 
                    is_nested_fam_and_assem = True, 
                    is_nested_family = True, 
                    is_nested_fam_or_assem = True, 
                    is_nested_private = True, 
                    is_nested_public = True, 
                    is_not_public = True, 
                    is_public = True, 
                    is_auto_layout = True, 
                    is_explicit_layout = True, 
                    is_layout_sequential = True, 
                    is_ansi_class = True, 
                    is_auto_class = True, 
                    is_unicode_class = True, 
                    is_com_object = True, 
                    is_contextful = True, 
                    is_enum = True, 
                    is_marshal_by_ref = True, 
                    is_primitive = True, 
                    is_value_type = True, 
                    is_signature_type = True, 
                    is_security_critical = True, 
                    is_security_safe_critical = True, 
                    is_security_transparent = True, 
                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                        type_id = null, ), 
                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        member_type = 'Constructor', ), 
                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                    guid = '0', 
                    base_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_serializable = True, 
                    contains_generic_parameters = True, 
                    is_visible = True, ), 
                module = redrover_api.models.module.Module(
                    assembly = redrover_api.models.assembly.Assembly(
                        defined_types = [
                            redrover_api.models.type_info.TypeInfo(
                                name = '0', 
                                custom_attributes = [
                                    redrover_api.models.custom_attribute_data.CustomAttributeData(
                                        attribute_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            declaring_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                declaring_method = redrover_api.models.method_base.MethodBase(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    reflected_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        underlying_system_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_type_arguments = [
                                                                redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                        type_id = null, 
                                                                        value = 'Sequential', ), 
                                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        attributes = 'ReuseSlot', 
                                                                        method_implementation_flags = 'Managed', 
                                                                        calling_convention = 'Standard', 
                                                                        is_abstract = True, 
                                                                        is_constructor = True, 
                                                                        is_final = True, 
                                                                        is_hide_by_sig = True, 
                                                                        is_special_name = True, 
                                                                        is_static = True, 
                                                                        is_virtual = True, 
                                                                        is_assembly = True, 
                                                                        is_family = True, 
                                                                        is_family_and_assembly = True, 
                                                                        is_family_or_assembly = True, 
                                                                        is_private = True, 
                                                                        is_public = True, 
                                                                        is_constructed_generic_method = True, 
                                                                        is_generic_method = True, 
                                                                        is_generic_method_definition = True, 
                                                                        contains_generic_parameters = True, 
                                                                        method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                                            value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        member_type = 'Constructor', ), 
                                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                    guid = '0', 
                                                                    base_type = redrover_api.models.type.Type(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        is_interface = True, 
                                                                        member_type = 'Constructor', 
                                                                        namespace = '0', 
                                                                        assembly_qualified_name = '0', 
                                                                        full_name = '0', 
                                                                        is_nested = True, 
                                                                        is_type_definition = True, 
                                                                        is_array = True, 
                                                                        is_by_ref = True, 
                                                                        is_pointer = True, 
                                                                        is_constructed_generic_type = True, 
                                                                        is_generic_parameter = True, 
                                                                        is_generic_type_parameter = True, 
                                                                        is_generic_method_parameter = True, 
                                                                        is_generic_type = True, 
                                                                        is_generic_type_definition = True, 
                                                                        is_sz_array = True, 
                                                                        is_variable_bound_array = True, 
                                                                        is_by_ref_like = True, 
                                                                        has_element_type = True, 
                                                                        generic_parameter_position = 56, 
                                                                        generic_parameter_attributes = 'None', 
                                                                        attributes = 'NotPublic', 
                                                                        is_abstract = True, 
                                                                        is_import = True, 
                                                                        is_sealed = True, 
                                                                        is_special_name = True, 
                                                                        is_class = True, 
                                                                        is_nested_assembly = True, 
                                                                        is_nested_fam_and_assem = True, 
                                                                        is_nested_family = True, 
                                                                        is_nested_fam_or_assem = True, 
                                                                        is_nested_private = True, 
                                                                        is_nested_public = True, 
                                                                        is_not_public = True, 
                                                                        is_public = True, 
                                                                        is_auto_layout = True, 
                                                                        is_explicit_layout = True, 
                                                                        is_layout_sequential = True, 
                                                                        is_ansi_class = True, 
                                                                        is_auto_class = True, 
                                                                        is_unicode_class = True, 
                                                                        is_com_object = True, 
                                                                        is_contextful = True, 
                                                                        is_enum = True, 
                                                                        is_marshal_by_ref = True, 
                                                                        is_primitive = True, 
                                                                        is_value_type = True, 
                                                                        is_signature_type = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        guid = '0', 
                                                                        is_serializable = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_visible = True, ), 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, )
                                                                ], 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                type_id = null, ), 
                                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', ), 
                                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                            guid = '0', 
                                                            base_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_type_arguments = [
                                                            redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, )
                                                            ], 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                            type_id = null, ), 
                                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', ), 
                                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                        guid = '0', 
                                                        base_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(), 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, ), 
                                                reflected_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                underlying_system_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_type_arguments = [
                                                    redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, )
                                                    ], 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                    type_id = null, ), 
                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', ), 
                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                guid = '0', 
                                                base_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            declaring_method = redrover_api.models.method_base.MethodBase(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, ), 
                                            reflected_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            underlying_system_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_type_arguments = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                type_id = null, ), 
                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', ), 
                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                            guid = '0', 
                                            base_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        constructor = redrover_api.models.constructor_info.ConstructorInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', ), 
                                        constructor_arguments = [
                                            redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                                argument_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), )
                                            ], 
                                        named_arguments = [
                                            redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                                member_info = redrover_api.models.member_info.MemberInfo(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, ), 
                                                typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                                member_name = '0', 
                                                is_field = True, )
                                            ], )
                                    ], 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                declaring_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                declaring_method = redrover_api.models.method_base.MethodBase(
                                    member_type = 'Constructor', 
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, ), 
                                reflected_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                underlying_system_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_type_arguments = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                    type_id = null, ), 
                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    member_type = 'Constructor', ), 
                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                guid = '0', 
                                base_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, 
                                generic_type_parameters = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                declared_constructors = [
                                    redrover_api.models.constructor_info.ConstructorInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', )
                                    ], 
                                declared_events = [
                                    redrover_api.models.event_info.EventInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        member_type = 'Constructor', 
                                        attributes = 'None', 
                                        is_special_name = True, 
                                        add_method = redrover_api.models.method_info.MethodInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', 
                                            return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                                                attributes = 'None', 
                                                member = redrover_api.models.member_info.MemberInfo(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, ), 
                                                name = '0', 
                                                parameter_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                position = 56, 
                                                is_in = True, 
                                                is_lcid = True, 
                                                is_optional = True, 
                                                is_out = True, 
                                                is_retval = True, 
                                                default_value = null, 
                                                raw_default_value = null, 
                                                has_default_value = True, 
                                                metadata_token = 56, ), 
                                            return_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                        remove_method = redrover_api.models.method_info.MethodInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', 
                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                        raise_method = redrover_api.models.method_info.MethodInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', 
                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                        is_multicast = True, 
                                        event_handler_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), )
                                    ], 
                                declared_fields = [
                                    redrover_api.models.field_info.FieldInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        member_type = 'Constructor', 
                                        attributes = 'PrivateScope', 
                                        field_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        is_init_only = True, 
                                        is_literal = True, 
                                        is_not_serialized = True, 
                                        is_pinvoke_impl = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                    ], 
                                declared_members = [
                                    redrover_api.models.member_info.MemberInfo(
                                        member_type = 'Constructor', 
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, )
                                    ], 
                                declared_methods = [
                                    redrover_api.models.method_info.MethodInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', 
                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                    ], 
                                declared_nested_types = [
                                    redrover_api.models.type_info.TypeInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, 
                                        declared_properties = [
                                            redrover_api.models.property_info.PropertyInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                member_type = 'Constructor', 
                                                property_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                attributes = 'None', 
                                                is_special_name = True, 
                                                can_read = True, 
                                                can_write = True, 
                                                get_method = redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                set_method = redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                            ], 
                                        implemented_interfaces = [
                                            redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, )
                                            ], )
                                    ], 
                                declared_properties = [
                                    redrover_api.models.property_info.PropertyInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        member_type = 'Constructor', 
                                        attributes = 'None', 
                                        is_special_name = True, 
                                        can_read = True, 
                                        can_write = True, )
                                    ], 
                                implemented_interfaces = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], )
                            ], 
                        exported_types = [
                            redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, )
                            ], 
                        code_base = '0', 
                        entry_point = redrover_api.models.method_info.MethodInfo(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            attributes = 'ReuseSlot', 
                            method_implementation_flags = 'Managed', 
                            calling_convention = 'Standard', 
                            is_abstract = True, 
                            is_constructor = True, 
                            is_final = True, 
                            is_hide_by_sig = True, 
                            is_special_name = True, 
                            is_static = True, 
                            is_virtual = True, 
                            is_assembly = True, 
                            is_family = True, 
                            is_family_and_assembly = True, 
                            is_family_or_assembly = True, 
                            is_private = True, 
                            is_public = True, 
                            is_constructed_generic_method = True, 
                            is_generic_method = True, 
                            is_generic_method_definition = True, 
                            contains_generic_parameters = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            member_type = 'Constructor', 
                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                        full_name = '0', 
                        image_runtime_version = '0', 
                        is_dynamic = True, 
                        location = '0', 
                        reflection_only = True, 
                        is_collectible = True, 
                        is_fully_trusted = True, 
                        custom_attributes = [
                            redrover_api.models.custom_attribute_data.CustomAttributeData()
                            ], 
                        escaped_code_base = '0', 
                        manifest_module = redrover_api.models.module.Module(
                            fully_qualified_name = '0', 
                            name = '0', 
                            md_stream_version = 56, 
                            module_version_id = '0', 
                            scope_name = '0', 
                            module_handle = redrover_api.models.module_handle.ModuleHandle(
                                md_stream_version = 56, ), 
                            metadata_token = 56, ), 
                        modules = [
                            redrover_api.models.module.Module(
                                fully_qualified_name = '0', 
                                name = '0', 
                                md_stream_version = 56, 
                                module_version_id = '0', 
                                scope_name = '0', 
                                metadata_token = 56, )
                            ], 
                        global_assembly_cache = True, 
                        host_context = 56, 
                        security_rule_set = 'None', ), 
                    fully_qualified_name = '0', 
                    name = '0', 
                    md_stream_version = 56, 
                    module_version_id = '0', 
                    scope_name = '0', 
                    module_handle = redrover_api.models.module_handle.ModuleHandle(
                        md_stream_version = 56, ), 
                    custom_attributes = [
                        redrover_api.models.custom_attribute_data.CustomAttributeData()
                        ], 
                    metadata_token = 56, ), 
                custom_attributes = [
                    redrover_api.models.custom_attribute_data.CustomAttributeData(
                        attribute_type = redrover_api.models.type.Type(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            assembly = redrover_api.models.assembly.Assembly(
                                defined_types = [
                                    redrover_api.models.type_info.TypeInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        module = redrover_api.models.module.Module(
                                            fully_qualified_name = '0', 
                                            name = '0', 
                                            md_stream_version = 56, 
                                            module_version_id = '0', 
                                            scope_name = '0', 
                                            module_handle = redrover_api.models.module_handle.ModuleHandle(
                                                md_stream_version = 56, ), 
                                            metadata_token = 56, ), 
                                        is_nested = True, 
                                        declaring_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            declaring_method = redrover_api.models.method_base.MethodBase(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                reflected_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    underlying_system_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_type_arguments = [
                                                            redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                    type_id = null, 
                                                                    value = 'Sequential', ), 
                                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    attributes = 'ReuseSlot', 
                                                                    method_implementation_flags = 'Managed', 
                                                                    calling_convention = 'Standard', 
                                                                    is_abstract = True, 
                                                                    is_constructor = True, 
                                                                    is_final = True, 
                                                                    is_hide_by_sig = True, 
                                                                    is_special_name = True, 
                                                                    is_static = True, 
                                                                    is_virtual = True, 
                                                                    is_assembly = True, 
                                                                    is_family = True, 
                                                                    is_family_and_assembly = True, 
                                                                    is_family_or_assembly = True, 
                                                                    is_private = True, 
                                                                    is_public = True, 
                                                                    is_constructed_generic_method = True, 
                                                                    is_generic_method = True, 
                                                                    is_generic_method_definition = True, 
                                                                    contains_generic_parameters = True, 
                                                                    method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                                        value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    member_type = 'Constructor', ), 
                                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                guid = '0', 
                                                                base_type = redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, ), 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, )
                                                            ], 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                            type_id = null, ), 
                                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', ), 
                                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                        guid = '0', 
                                                        base_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_type_arguments = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                        type_id = null, ), 
                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', ), 
                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                    guid = '0', 
                                                    base_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(), 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, ), 
                                            reflected_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            underlying_system_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_type_arguments = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                type_id = null, ), 
                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', ), 
                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                            guid = '0', 
                                            base_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        declaring_method = redrover_api.models.method_base.MethodBase(
                                            member_type = 'Constructor', 
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, ), 
                                        reflected_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        underlying_system_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_type_arguments = [
                                            redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, )
                                            ], 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                            type_id = null, ), 
                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', ), 
                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                        guid = '0', 
                                        base_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, 
                                        generic_type_parameters = [
                                            redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, )
                                            ], 
                                        declared_constructors = [
                                            redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', )
                                            ], 
                                        declared_events = [
                                            redrover_api.models.event_info.EventInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                member_type = 'Constructor', 
                                                attributes = 'None', 
                                                is_special_name = True, 
                                                add_method = redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                                                        attributes = 'None', 
                                                        member = redrover_api.models.member_info.MemberInfo(
                                                            member_type = 'Constructor', 
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, ), 
                                                        name = '0', 
                                                        parameter_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        position = 56, 
                                                        is_in = True, 
                                                        is_lcid = True, 
                                                        is_optional = True, 
                                                        is_out = True, 
                                                        is_retval = True, 
                                                        default_value = null, 
                                                        raw_default_value = null, 
                                                        has_default_value = True, 
                                                        metadata_token = 56, ), 
                                                    return_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                remove_method = redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                raise_method = redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                is_multicast = True, 
                                                event_handler_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), )
                                            ], 
                                        declared_fields = [
                                            redrover_api.models.field_info.FieldInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                member_type = 'Constructor', 
                                                attributes = 'PrivateScope', 
                                                field_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_init_only = True, 
                                                is_literal = True, 
                                                is_not_serialized = True, 
                                                is_pinvoke_impl = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                            ], 
                                        declared_members = [
                                            redrover_api.models.member_info.MemberInfo(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, )
                                            ], 
                                        declared_methods = [
                                            redrover_api.models.method_info.MethodInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', 
                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                            ], 
                                        declared_nested_types = [
                                            redrover_api.models.type_info.TypeInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, 
                                                declared_properties = [
                                                    redrover_api.models.property_info.PropertyInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        member_type = 'Constructor', 
                                                        property_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        attributes = 'None', 
                                                        is_special_name = True, 
                                                        can_read = True, 
                                                        can_write = True, 
                                                        get_method = redrover_api.models.method_info.MethodInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', 
                                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                        set_method = redrover_api.models.method_info.MethodInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', 
                                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                                    ], 
                                                implemented_interfaces = [
                                                    redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, )
                                                    ], )
                                            ], 
                                        declared_properties = [
                                            redrover_api.models.property_info.PropertyInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                member_type = 'Constructor', 
                                                attributes = 'None', 
                                                is_special_name = True, 
                                                can_read = True, 
                                                can_write = True, )
                                            ], 
                                        implemented_interfaces = [
                                            redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, )
                                            ], )
                                    ], 
                                exported_types = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                code_base = '0', 
                                entry_point = redrover_api.models.method_info.MethodInfo(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    member_type = 'Constructor', 
                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                full_name = '0', 
                                image_runtime_version = '0', 
                                is_dynamic = True, 
                                location = '0', 
                                reflection_only = True, 
                                is_collectible = True, 
                                is_fully_trusted = True, 
                                escaped_code_base = '0', 
                                manifest_module = redrover_api.models.module.Module(
                                    fully_qualified_name = '0', 
                                    name = '0', 
                                    md_stream_version = 56, 
                                    module_version_id = '0', 
                                    scope_name = '0', 
                                    metadata_token = 56, ), 
                                modules = [
                                    redrover_api.models.module.Module(
                                        fully_qualified_name = '0', 
                                        name = '0', 
                                        md_stream_version = 56, 
                                        module_version_id = '0', 
                                        scope_name = '0', 
                                        metadata_token = 56, )
                                    ], 
                                global_assembly_cache = True, 
                                host_context = 56, 
                                security_rule_set = 'None', ), 
                            module = redrover_api.models.module.Module(
                                fully_qualified_name = '0', 
                                name = '0', 
                                md_stream_version = 56, 
                                module_version_id = '0', 
                                scope_name = '0', 
                                metadata_token = 56, ), 
                            is_nested = True, 
                            declaring_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            declaring_method = redrover_api.models.method_base.MethodBase(
                                member_type = 'Constructor', 
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, ), 
                            reflected_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            underlying_system_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_type_arguments = [
                                redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, )
                                ], 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                type_id = null, ), 
                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                member_type = 'Constructor', ), 
                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                            guid = '0', 
                            base_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, ), 
                        constructor = redrover_api.models.constructor_info.ConstructorInfo(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            attributes = 'ReuseSlot', 
                            method_implementation_flags = 'Managed', 
                            calling_convention = 'Standard', 
                            is_abstract = True, 
                            is_constructor = True, 
                            is_final = True, 
                            is_hide_by_sig = True, 
                            is_special_name = True, 
                            is_static = True, 
                            is_virtual = True, 
                            is_assembly = True, 
                            is_family = True, 
                            is_family_and_assembly = True, 
                            is_family_or_assembly = True, 
                            is_private = True, 
                            is_public = True, 
                            is_constructed_generic_method = True, 
                            is_generic_method = True, 
                            is_generic_method_definition = True, 
                            contains_generic_parameters = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            member_type = 'Constructor', ), 
                        constructor_arguments = [
                            redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                argument_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), )
                            ], 
                        named_arguments = [
                            redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                member_info = redrover_api.models.member_info.MemberInfo(
                                    member_type = 'Constructor', 
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, ), 
                                typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                member_name = '0', 
                                is_field = True, )
                            ], )
                    ], 
                is_collectible = True, 
                metadata_token = 56, 
                attributes = 'ReuseSlot', 
                method_implementation_flags = 'Managed', 
                calling_convention = 'Standard', 
                is_abstract = True, 
                is_constructor = True, 
                is_final = True, 
                is_hide_by_sig = True, 
                is_special_name = True, 
                is_static = True, 
                is_virtual = True, 
                is_assembly = True, 
                is_family = True, 
                is_family_and_assembly = True, 
                is_family_or_assembly = True, 
                is_private = True, 
                is_public = True, 
                is_constructed_generic_method = True, 
                is_generic_method = True, 
                is_generic_method_definition = True, 
                contains_generic_parameters = True, 
                method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                    value = redrover_api.models.int_ptr.IntPtr(), ), 
                is_security_critical = True, 
                is_security_safe_critical = True, 
                is_security_transparent = True, 
                member_type = 'Constructor', 
                return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                    attributes = 'None', 
                    member = redrover_api.models.member_info.MemberInfo(
                        member_type = 'Constructor', 
                        declaring_type = redrover_api.models.type.Type(
                            name = '0', 
                            custom_attributes = [
                                redrover_api.models.custom_attribute_data.CustomAttributeData(
                                    attribute_type = redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        assembly = redrover_api.models.assembly.Assembly(
                                            defined_types = [
                                                redrover_api.models.type_info.TypeInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    module = redrover_api.models.module.Module(
                                                        fully_qualified_name = '0', 
                                                        name = '0', 
                                                        md_stream_version = 56, 
                                                        module_version_id = '0', 
                                                        scope_name = '0', 
                                                        module_handle = redrover_api.models.module_handle.ModuleHandle(
                                                            md_stream_version = 56, ), 
                                                        metadata_token = 56, ), 
                                                    is_nested = True, 
                                                    declaring_method = redrover_api.models.method_base.MethodBase(
                                                        member_type = 'Constructor', 
                                                        name = '0', 
                                                        reflected_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            underlying_system_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_type_arguments = [
                                                                    redrover_api.models.type.Type(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        is_interface = True, 
                                                                        member_type = 'Constructor', 
                                                                        namespace = '0', 
                                                                        assembly_qualified_name = '0', 
                                                                        full_name = '0', 
                                                                        is_nested = True, 
                                                                        is_type_definition = True, 
                                                                        is_array = True, 
                                                                        is_by_ref = True, 
                                                                        is_pointer = True, 
                                                                        is_constructed_generic_type = True, 
                                                                        is_generic_parameter = True, 
                                                                        is_generic_type_parameter = True, 
                                                                        is_generic_method_parameter = True, 
                                                                        is_generic_type = True, 
                                                                        is_generic_type_definition = True, 
                                                                        is_sz_array = True, 
                                                                        is_variable_bound_array = True, 
                                                                        is_by_ref_like = True, 
                                                                        has_element_type = True, 
                                                                        generic_parameter_position = 56, 
                                                                        generic_parameter_attributes = 'None', 
                                                                        attributes = 'NotPublic', 
                                                                        is_abstract = True, 
                                                                        is_import = True, 
                                                                        is_sealed = True, 
                                                                        is_special_name = True, 
                                                                        is_class = True, 
                                                                        is_nested_assembly = True, 
                                                                        is_nested_fam_and_assem = True, 
                                                                        is_nested_family = True, 
                                                                        is_nested_fam_or_assem = True, 
                                                                        is_nested_private = True, 
                                                                        is_nested_public = True, 
                                                                        is_not_public = True, 
                                                                        is_public = True, 
                                                                        is_auto_layout = True, 
                                                                        is_explicit_layout = True, 
                                                                        is_layout_sequential = True, 
                                                                        is_ansi_class = True, 
                                                                        is_auto_class = True, 
                                                                        is_unicode_class = True, 
                                                                        is_com_object = True, 
                                                                        is_contextful = True, 
                                                                        is_enum = True, 
                                                                        is_marshal_by_ref = True, 
                                                                        is_primitive = True, 
                                                                        is_value_type = True, 
                                                                        is_signature_type = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                            type_id = null, 
                                                                            value = 'Sequential', ), 
                                                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                            name = '0', 
                                                                            is_collectible = True, 
                                                                            metadata_token = 56, 
                                                                            attributes = 'ReuseSlot', 
                                                                            method_implementation_flags = 'Managed', 
                                                                            calling_convention = 'Standard', 
                                                                            is_abstract = True, 
                                                                            is_constructor = True, 
                                                                            is_final = True, 
                                                                            is_hide_by_sig = True, 
                                                                            is_special_name = True, 
                                                                            is_static = True, 
                                                                            is_virtual = True, 
                                                                            is_assembly = True, 
                                                                            is_family = True, 
                                                                            is_family_and_assembly = True, 
                                                                            is_family_or_assembly = True, 
                                                                            is_private = True, 
                                                                            is_public = True, 
                                                                            is_constructed_generic_method = True, 
                                                                            is_generic_method = True, 
                                                                            is_generic_method_definition = True, 
                                                                            contains_generic_parameters = True, 
                                                                            method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                                                value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                                            is_security_critical = True, 
                                                                            is_security_safe_critical = True, 
                                                                            is_security_transparent = True, 
                                                                            member_type = 'Constructor', ), 
                                                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                        guid = '0', 
                                                                        base_type = redrover_api.models.type.Type(
                                                                            name = '0', 
                                                                            is_collectible = True, 
                                                                            metadata_token = 56, 
                                                                            is_interface = True, 
                                                                            member_type = 'Constructor', 
                                                                            namespace = '0', 
                                                                            assembly_qualified_name = '0', 
                                                                            full_name = '0', 
                                                                            is_nested = True, 
                                                                            is_type_definition = True, 
                                                                            is_array = True, 
                                                                            is_by_ref = True, 
                                                                            is_pointer = True, 
                                                                            is_constructed_generic_type = True, 
                                                                            is_generic_parameter = True, 
                                                                            is_generic_type_parameter = True, 
                                                                            is_generic_method_parameter = True, 
                                                                            is_generic_type = True, 
                                                                            is_generic_type_definition = True, 
                                                                            is_sz_array = True, 
                                                                            is_variable_bound_array = True, 
                                                                            is_by_ref_like = True, 
                                                                            has_element_type = True, 
                                                                            generic_parameter_position = 56, 
                                                                            generic_parameter_attributes = 'None', 
                                                                            attributes = 'NotPublic', 
                                                                            is_abstract = True, 
                                                                            is_import = True, 
                                                                            is_sealed = True, 
                                                                            is_special_name = True, 
                                                                            is_class = True, 
                                                                            is_nested_assembly = True, 
                                                                            is_nested_fam_and_assem = True, 
                                                                            is_nested_family = True, 
                                                                            is_nested_fam_or_assem = True, 
                                                                            is_nested_private = True, 
                                                                            is_nested_public = True, 
                                                                            is_not_public = True, 
                                                                            is_public = True, 
                                                                            is_auto_layout = True, 
                                                                            is_explicit_layout = True, 
                                                                            is_layout_sequential = True, 
                                                                            is_ansi_class = True, 
                                                                            is_auto_class = True, 
                                                                            is_unicode_class = True, 
                                                                            is_com_object = True, 
                                                                            is_contextful = True, 
                                                                            is_enum = True, 
                                                                            is_marshal_by_ref = True, 
                                                                            is_primitive = True, 
                                                                            is_value_type = True, 
                                                                            is_signature_type = True, 
                                                                            is_security_critical = True, 
                                                                            is_security_safe_critical = True, 
                                                                            is_security_transparent = True, 
                                                                            guid = '0', 
                                                                            is_serializable = True, 
                                                                            contains_generic_parameters = True, 
                                                                            is_visible = True, ), 
                                                                        is_serializable = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_visible = True, )
                                                                    ], 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                    type_id = null, ), 
                                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    attributes = 'ReuseSlot', 
                                                                    method_implementation_flags = 'Managed', 
                                                                    calling_convention = 'Standard', 
                                                                    is_abstract = True, 
                                                                    is_constructor = True, 
                                                                    is_final = True, 
                                                                    is_hide_by_sig = True, 
                                                                    is_special_name = True, 
                                                                    is_static = True, 
                                                                    is_virtual = True, 
                                                                    is_assembly = True, 
                                                                    is_family = True, 
                                                                    is_family_and_assembly = True, 
                                                                    is_family_or_assembly = True, 
                                                                    is_private = True, 
                                                                    is_public = True, 
                                                                    is_constructed_generic_method = True, 
                                                                    is_generic_method = True, 
                                                                    is_generic_method_definition = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    member_type = 'Constructor', ), 
                                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                guid = '0', 
                                                                base_type = redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, ), 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_type_arguments = [
                                                                redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, )
                                                                ], 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                type_id = null, ), 
                                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', ), 
                                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                            guid = '0', 
                                                            base_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(), 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, ), 
                                                    reflected_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    underlying_system_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_type_arguments = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                        type_id = null, ), 
                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', ), 
                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                    guid = '0', 
                                                    base_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, 
                                                    generic_type_parameters = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], 
                                                    declared_constructors = [
                                                        redrover_api.models.constructor_info.ConstructorInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', )
                                                        ], 
                                                    declared_events = [
                                                        redrover_api.models.event_info.EventInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            attributes = 'None', 
                                                            is_special_name = True, 
                                                            add_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type = redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, ), 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            remove_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            raise_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            is_multicast = True, 
                                                            event_handler_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), )
                                                        ], 
                                                    declared_fields = [
                                                        redrover_api.models.field_info.FieldInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            attributes = 'PrivateScope', 
                                                            field_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_init_only = True, 
                                                            is_literal = True, 
                                                            is_not_serialized = True, 
                                                            is_pinvoke_impl = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                                        ], 
                                                    declared_members = [
                                                        redrover_api.models.member_info.MemberInfo(
                                                            member_type = 'Constructor', 
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, )
                                                        ], 
                                                    declared_methods = [
                                                        redrover_api.models.method_info.MethodInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', 
                                                            return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                                        ], 
                                                    declared_nested_types = [
                                                        redrover_api.models.type_info.TypeInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, 
                                                            declared_properties = [
                                                                redrover_api.models.property_info.PropertyInfo(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    member_type = 'Constructor', 
                                                                    property_type = redrover_api.models.type.Type(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        is_interface = True, 
                                                                        member_type = 'Constructor', 
                                                                        namespace = '0', 
                                                                        assembly_qualified_name = '0', 
                                                                        full_name = '0', 
                                                                        is_nested = True, 
                                                                        is_type_definition = True, 
                                                                        is_array = True, 
                                                                        is_by_ref = True, 
                                                                        is_pointer = True, 
                                                                        is_constructed_generic_type = True, 
                                                                        is_generic_parameter = True, 
                                                                        is_generic_type_parameter = True, 
                                                                        is_generic_method_parameter = True, 
                                                                        is_generic_type = True, 
                                                                        is_generic_type_definition = True, 
                                                                        is_sz_array = True, 
                                                                        is_variable_bound_array = True, 
                                                                        is_by_ref_like = True, 
                                                                        has_element_type = True, 
                                                                        generic_parameter_position = 56, 
                                                                        generic_parameter_attributes = 'None', 
                                                                        attributes = 'NotPublic', 
                                                                        is_abstract = True, 
                                                                        is_import = True, 
                                                                        is_sealed = True, 
                                                                        is_special_name = True, 
                                                                        is_class = True, 
                                                                        is_nested_assembly = True, 
                                                                        is_nested_fam_and_assem = True, 
                                                                        is_nested_family = True, 
                                                                        is_nested_fam_or_assem = True, 
                                                                        is_nested_private = True, 
                                                                        is_nested_public = True, 
                                                                        is_not_public = True, 
                                                                        is_public = True, 
                                                                        is_auto_layout = True, 
                                                                        is_explicit_layout = True, 
                                                                        is_layout_sequential = True, 
                                                                        is_ansi_class = True, 
                                                                        is_auto_class = True, 
                                                                        is_unicode_class = True, 
                                                                        is_com_object = True, 
                                                                        is_contextful = True, 
                                                                        is_enum = True, 
                                                                        is_marshal_by_ref = True, 
                                                                        is_primitive = True, 
                                                                        is_value_type = True, 
                                                                        is_signature_type = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        guid = '0', 
                                                                        is_serializable = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_visible = True, ), 
                                                                    attributes = 'None', 
                                                                    is_special_name = True, 
                                                                    can_read = True, 
                                                                    can_write = True, 
                                                                    get_method = redrover_api.models.method_info.MethodInfo(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        attributes = 'ReuseSlot', 
                                                                        method_implementation_flags = 'Managed', 
                                                                        calling_convention = 'Standard', 
                                                                        is_abstract = True, 
                                                                        is_constructor = True, 
                                                                        is_final = True, 
                                                                        is_hide_by_sig = True, 
                                                                        is_special_name = True, 
                                                                        is_static = True, 
                                                                        is_virtual = True, 
                                                                        is_assembly = True, 
                                                                        is_family = True, 
                                                                        is_family_and_assembly = True, 
                                                                        is_family_or_assembly = True, 
                                                                        is_private = True, 
                                                                        is_public = True, 
                                                                        is_constructed_generic_method = True, 
                                                                        is_generic_method = True, 
                                                                        is_generic_method_definition = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        member_type = 'Constructor', 
                                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                                    set_method = redrover_api.models.method_info.MethodInfo(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        attributes = 'ReuseSlot', 
                                                                        method_implementation_flags = 'Managed', 
                                                                        calling_convention = 'Standard', 
                                                                        is_abstract = True, 
                                                                        is_constructor = True, 
                                                                        is_final = True, 
                                                                        is_hide_by_sig = True, 
                                                                        is_special_name = True, 
                                                                        is_static = True, 
                                                                        is_virtual = True, 
                                                                        is_assembly = True, 
                                                                        is_family = True, 
                                                                        is_family_and_assembly = True, 
                                                                        is_family_or_assembly = True, 
                                                                        is_private = True, 
                                                                        is_public = True, 
                                                                        is_constructed_generic_method = True, 
                                                                        is_generic_method = True, 
                                                                        is_generic_method_definition = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        member_type = 'Constructor', 
                                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                                                ], 
                                                            implemented_interfaces = [
                                                                redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    guid = '0', 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, )
                                                                ], )
                                                        ], 
                                                    declared_properties = [
                                                        redrover_api.models.property_info.PropertyInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            attributes = 'None', 
                                                            is_special_name = True, 
                                                            can_read = True, 
                                                            can_write = True, )
                                                        ], 
                                                    implemented_interfaces = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], )
                                                ], 
                                            exported_types = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            code_base = '0', 
                                            entry_point = redrover_api.models.method_info.MethodInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', 
                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                            full_name = '0', 
                                            image_runtime_version = '0', 
                                            is_dynamic = True, 
                                            location = '0', 
                                            reflection_only = True, 
                                            is_collectible = True, 
                                            is_fully_trusted = True, 
                                            escaped_code_base = '0', 
                                            manifest_module = redrover_api.models.module.Module(
                                                fully_qualified_name = '0', 
                                                name = '0', 
                                                md_stream_version = 56, 
                                                module_version_id = '0', 
                                                scope_name = '0', 
                                                metadata_token = 56, ), 
                                            modules = [
                                                redrover_api.models.module.Module(
                                                    fully_qualified_name = '0', 
                                                    name = '0', 
                                                    md_stream_version = 56, 
                                                    module_version_id = '0', 
                                                    scope_name = '0', 
                                                    metadata_token = 56, )
                                                ], 
                                            global_assembly_cache = True, 
                                            host_context = 56, 
                                            security_rule_set = 'None', ), 
                                        module = redrover_api.models.module.Module(
                                            fully_qualified_name = '0', 
                                            name = '0', 
                                            md_stream_version = 56, 
                                            module_version_id = '0', 
                                            scope_name = '0', 
                                            metadata_token = 56, ), 
                                        is_nested = True, 
                                        declaring_method = redrover_api.models.method_base.MethodBase(
                                            member_type = 'Constructor', 
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, ), 
                                        reflected_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        underlying_system_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_type_arguments = [
                                            redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, )
                                            ], 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                            type_id = null, ), 
                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            attributes = 'ReuseSlot', 
                                            method_implementation_flags = 'Managed', 
                                            calling_convention = 'Standard', 
                                            is_abstract = True, 
                                            is_constructor = True, 
                                            is_final = True, 
                                            is_hide_by_sig = True, 
                                            is_special_name = True, 
                                            is_static = True, 
                                            is_virtual = True, 
                                            is_assembly = True, 
                                            is_family = True, 
                                            is_family_and_assembly = True, 
                                            is_family_or_assembly = True, 
                                            is_private = True, 
                                            is_public = True, 
                                            is_constructed_generic_method = True, 
                                            is_generic_method = True, 
                                            is_generic_method_definition = True, 
                                            contains_generic_parameters = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            member_type = 'Constructor', ), 
                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                        guid = '0', 
                                        base_type = redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, ), 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, ), 
                                    constructor = redrover_api.models.constructor_info.ConstructorInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', ), 
                                    constructor_arguments = [
                                        redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                            argument_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), )
                                        ], 
                                    named_arguments = [
                                        redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                            member_info = redrover_api.models.member_info.MemberInfo(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, ), 
                                            typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                            member_name = '0', 
                                            is_field = True, )
                                        ], )
                                ], 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            assembly = redrover_api.models.assembly.Assembly(
                                code_base = '0', 
                                full_name = '0', 
                                image_runtime_version = '0', 
                                is_dynamic = True, 
                                location = '0', 
                                reflection_only = True, 
                                is_collectible = True, 
                                is_fully_trusted = True, 
                                escaped_code_base = '0', 
                                global_assembly_cache = True, 
                                host_context = 56, 
                                security_rule_set = 'None', ), 
                            module = redrover_api.models.module.Module(
                                fully_qualified_name = '0', 
                                name = '0', 
                                md_stream_version = 56, 
                                module_version_id = '0', 
                                scope_name = '0', 
                                metadata_token = 56, ), 
                            is_nested = True, 
                            declaring_method = redrover_api.models.method_base.MethodBase(
                                member_type = 'Constructor', 
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, ), 
                            reflected_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            underlying_system_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_type_arguments = [
                                redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, )
                                ], 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                type_id = null, ), 
                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                member_type = 'Constructor', ), 
                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                            guid = '0', 
                            base_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                is_nested = True, 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                guid = '0', 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, ), 
                        reflected_type = redrover_api.models.type.Type(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            is_nested = True, 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            guid = '0', 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, ), 
                        name = '0', 
                        module = redrover_api.models.module.Module(
                            fully_qualified_name = '0', 
                            name = '0', 
                            md_stream_version = 56, 
                            module_version_id = '0', 
                            scope_name = '0', 
                            metadata_token = 56, ), 
                        custom_attributes = [
                            redrover_api.models.custom_attribute_data.CustomAttributeData()
                            ], 
                        is_collectible = True, 
                        metadata_token = 56, ), 
                    name = '0', 
                    parameter_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    position = 56, 
                    is_in = True, 
                    is_lcid = True, 
                    is_optional = True, 
                    is_out = True, 
                    is_retval = True, 
                    default_value = null, 
                    raw_default_value = null, 
                    has_default_value = True, 
                    custom_attributes = [
                        redrover_api.models.custom_attribute_data.CustomAttributeData()
                        ], 
                    metadata_token = 56, ), 
                return_type = redrover_api.models.type.Type(
                    name = '0', 
                    custom_attributes = [
                        redrover_api.models.custom_attribute_data.CustomAttributeData(
                            attribute_type = redrover_api.models.type.Type(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                is_interface = True, 
                                member_type = 'Constructor', 
                                namespace = '0', 
                                assembly_qualified_name = '0', 
                                full_name = '0', 
                                assembly = redrover_api.models.assembly.Assembly(
                                    defined_types = [
                                        redrover_api.models.type_info.TypeInfo(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            module = redrover_api.models.module.Module(
                                                fully_qualified_name = '0', 
                                                name = '0', 
                                                md_stream_version = 56, 
                                                module_version_id = '0', 
                                                scope_name = '0', 
                                                module_handle = redrover_api.models.module_handle.ModuleHandle(
                                                    md_stream_version = 56, ), 
                                                metadata_token = 56, ), 
                                            is_nested = True, 
                                            declaring_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                declaring_method = redrover_api.models.method_base.MethodBase(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    reflected_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        underlying_system_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_type_arguments = [
                                                                redrover_api.models.type.Type(
                                                                    name = '0', 
                                                                    is_collectible = True, 
                                                                    metadata_token = 56, 
                                                                    is_interface = True, 
                                                                    member_type = 'Constructor', 
                                                                    namespace = '0', 
                                                                    assembly_qualified_name = '0', 
                                                                    full_name = '0', 
                                                                    is_nested = True, 
                                                                    is_type_definition = True, 
                                                                    is_array = True, 
                                                                    is_by_ref = True, 
                                                                    is_pointer = True, 
                                                                    is_constructed_generic_type = True, 
                                                                    is_generic_parameter = True, 
                                                                    is_generic_type_parameter = True, 
                                                                    is_generic_method_parameter = True, 
                                                                    is_generic_type = True, 
                                                                    is_generic_type_definition = True, 
                                                                    is_sz_array = True, 
                                                                    is_variable_bound_array = True, 
                                                                    is_by_ref_like = True, 
                                                                    has_element_type = True, 
                                                                    generic_parameter_position = 56, 
                                                                    generic_parameter_attributes = 'None', 
                                                                    attributes = 'NotPublic', 
                                                                    is_abstract = True, 
                                                                    is_import = True, 
                                                                    is_sealed = True, 
                                                                    is_special_name = True, 
                                                                    is_class = True, 
                                                                    is_nested_assembly = True, 
                                                                    is_nested_fam_and_assem = True, 
                                                                    is_nested_family = True, 
                                                                    is_nested_fam_or_assem = True, 
                                                                    is_nested_private = True, 
                                                                    is_nested_public = True, 
                                                                    is_not_public = True, 
                                                                    is_public = True, 
                                                                    is_auto_layout = True, 
                                                                    is_explicit_layout = True, 
                                                                    is_layout_sequential = True, 
                                                                    is_ansi_class = True, 
                                                                    is_auto_class = True, 
                                                                    is_unicode_class = True, 
                                                                    is_com_object = True, 
                                                                    is_contextful = True, 
                                                                    is_enum = True, 
                                                                    is_marshal_by_ref = True, 
                                                                    is_primitive = True, 
                                                                    is_value_type = True, 
                                                                    is_signature_type = True, 
                                                                    is_security_critical = True, 
                                                                    is_security_safe_critical = True, 
                                                                    is_security_transparent = True, 
                                                                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                        type_id = null, 
                                                                        value = 'Sequential', ), 
                                                                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        attributes = 'ReuseSlot', 
                                                                        method_implementation_flags = 'Managed', 
                                                                        calling_convention = 'Standard', 
                                                                        is_abstract = True, 
                                                                        is_constructor = True, 
                                                                        is_final = True, 
                                                                        is_hide_by_sig = True, 
                                                                        is_special_name = True, 
                                                                        is_static = True, 
                                                                        is_virtual = True, 
                                                                        is_assembly = True, 
                                                                        is_family = True, 
                                                                        is_family_and_assembly = True, 
                                                                        is_family_or_assembly = True, 
                                                                        is_private = True, 
                                                                        is_public = True, 
                                                                        is_constructed_generic_method = True, 
                                                                        is_generic_method = True, 
                                                                        is_generic_method_definition = True, 
                                                                        contains_generic_parameters = True, 
                                                                        method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(
                                                                            value = redrover_api.models.int_ptr.IntPtr(), ), 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        member_type = 'Constructor', ), 
                                                                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                                    guid = '0', 
                                                                    base_type = redrover_api.models.type.Type(
                                                                        name = '0', 
                                                                        is_collectible = True, 
                                                                        metadata_token = 56, 
                                                                        is_interface = True, 
                                                                        member_type = 'Constructor', 
                                                                        namespace = '0', 
                                                                        assembly_qualified_name = '0', 
                                                                        full_name = '0', 
                                                                        is_nested = True, 
                                                                        is_type_definition = True, 
                                                                        is_array = True, 
                                                                        is_by_ref = True, 
                                                                        is_pointer = True, 
                                                                        is_constructed_generic_type = True, 
                                                                        is_generic_parameter = True, 
                                                                        is_generic_type_parameter = True, 
                                                                        is_generic_method_parameter = True, 
                                                                        is_generic_type = True, 
                                                                        is_generic_type_definition = True, 
                                                                        is_sz_array = True, 
                                                                        is_variable_bound_array = True, 
                                                                        is_by_ref_like = True, 
                                                                        has_element_type = True, 
                                                                        generic_parameter_position = 56, 
                                                                        generic_parameter_attributes = 'None', 
                                                                        attributes = 'NotPublic', 
                                                                        is_abstract = True, 
                                                                        is_import = True, 
                                                                        is_sealed = True, 
                                                                        is_special_name = True, 
                                                                        is_class = True, 
                                                                        is_nested_assembly = True, 
                                                                        is_nested_fam_and_assem = True, 
                                                                        is_nested_family = True, 
                                                                        is_nested_fam_or_assem = True, 
                                                                        is_nested_private = True, 
                                                                        is_nested_public = True, 
                                                                        is_not_public = True, 
                                                                        is_public = True, 
                                                                        is_auto_layout = True, 
                                                                        is_explicit_layout = True, 
                                                                        is_layout_sequential = True, 
                                                                        is_ansi_class = True, 
                                                                        is_auto_class = True, 
                                                                        is_unicode_class = True, 
                                                                        is_com_object = True, 
                                                                        is_contextful = True, 
                                                                        is_enum = True, 
                                                                        is_marshal_by_ref = True, 
                                                                        is_primitive = True, 
                                                                        is_value_type = True, 
                                                                        is_signature_type = True, 
                                                                        is_security_critical = True, 
                                                                        is_security_safe_critical = True, 
                                                                        is_security_transparent = True, 
                                                                        guid = '0', 
                                                                        is_serializable = True, 
                                                                        contains_generic_parameters = True, 
                                                                        is_visible = True, ), 
                                                                    is_serializable = True, 
                                                                    contains_generic_parameters = True, 
                                                                    is_visible = True, )
                                                                ], 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                                type_id = null, ), 
                                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', ), 
                                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                            guid = '0', 
                                                            base_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_type_arguments = [
                                                            redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, )
                                                            ], 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                            type_id = null, ), 
                                                        type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            attributes = 'ReuseSlot', 
                                                            method_implementation_flags = 'Managed', 
                                                            calling_convention = 'Standard', 
                                                            is_abstract = True, 
                                                            is_constructor = True, 
                                                            is_final = True, 
                                                            is_hide_by_sig = True, 
                                                            is_special_name = True, 
                                                            is_static = True, 
                                                            is_virtual = True, 
                                                            is_assembly = True, 
                                                            is_family = True, 
                                                            is_family_and_assembly = True, 
                                                            is_family_or_assembly = True, 
                                                            is_private = True, 
                                                            is_public = True, 
                                                            is_constructed_generic_method = True, 
                                                            is_generic_method = True, 
                                                            is_generic_method_definition = True, 
                                                            contains_generic_parameters = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            member_type = 'Constructor', ), 
                                                        type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                        guid = '0', 
                                                        base_type = redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, ), 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    method_handle = redrover_api.models.runtime_method_handle.RuntimeMethodHandle(), 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, ), 
                                                reflected_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                underlying_system_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_type_arguments = [
                                                    redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, )
                                                    ], 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                    type_id = null, ), 
                                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', ), 
                                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                                guid = '0', 
                                                base_type = redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, ), 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            declaring_method = redrover_api.models.method_base.MethodBase(
                                                member_type = 'Constructor', 
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, ), 
                                            reflected_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            underlying_system_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_type_arguments = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                                type_id = null, ), 
                                            type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                attributes = 'ReuseSlot', 
                                                method_implementation_flags = 'Managed', 
                                                calling_convention = 'Standard', 
                                                is_abstract = True, 
                                                is_constructor = True, 
                                                is_final = True, 
                                                is_hide_by_sig = True, 
                                                is_special_name = True, 
                                                is_static = True, 
                                                is_virtual = True, 
                                                is_assembly = True, 
                                                is_family = True, 
                                                is_family_and_assembly = True, 
                                                is_family_or_assembly = True, 
                                                is_private = True, 
                                                is_public = True, 
                                                is_constructed_generic_method = True, 
                                                is_generic_method = True, 
                                                is_generic_method_definition = True, 
                                                contains_generic_parameters = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                member_type = 'Constructor', ), 
                                            type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                            guid = '0', 
                                            base_type = redrover_api.models.type.Type(
                                                name = '0', 
                                                is_collectible = True, 
                                                metadata_token = 56, 
                                                is_interface = True, 
                                                member_type = 'Constructor', 
                                                namespace = '0', 
                                                assembly_qualified_name = '0', 
                                                full_name = '0', 
                                                is_nested = True, 
                                                is_type_definition = True, 
                                                is_array = True, 
                                                is_by_ref = True, 
                                                is_pointer = True, 
                                                is_constructed_generic_type = True, 
                                                is_generic_parameter = True, 
                                                is_generic_type_parameter = True, 
                                                is_generic_method_parameter = True, 
                                                is_generic_type = True, 
                                                is_generic_type_definition = True, 
                                                is_sz_array = True, 
                                                is_variable_bound_array = True, 
                                                is_by_ref_like = True, 
                                                has_element_type = True, 
                                                generic_parameter_position = 56, 
                                                generic_parameter_attributes = 'None', 
                                                attributes = 'NotPublic', 
                                                is_abstract = True, 
                                                is_import = True, 
                                                is_sealed = True, 
                                                is_special_name = True, 
                                                is_class = True, 
                                                is_nested_assembly = True, 
                                                is_nested_fam_and_assem = True, 
                                                is_nested_family = True, 
                                                is_nested_fam_or_assem = True, 
                                                is_nested_private = True, 
                                                is_nested_public = True, 
                                                is_not_public = True, 
                                                is_public = True, 
                                                is_auto_layout = True, 
                                                is_explicit_layout = True, 
                                                is_layout_sequential = True, 
                                                is_ansi_class = True, 
                                                is_auto_class = True, 
                                                is_unicode_class = True, 
                                                is_com_object = True, 
                                                is_contextful = True, 
                                                is_enum = True, 
                                                is_marshal_by_ref = True, 
                                                is_primitive = True, 
                                                is_value_type = True, 
                                                is_signature_type = True, 
                                                is_security_critical = True, 
                                                is_security_safe_critical = True, 
                                                is_security_transparent = True, 
                                                guid = '0', 
                                                is_serializable = True, 
                                                contains_generic_parameters = True, 
                                                is_visible = True, ), 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, 
                                            generic_type_parameters = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], 
                                            declared_constructors = [
                                                redrover_api.models.constructor_info.ConstructorInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', )
                                                ], 
                                            declared_events = [
                                                redrover_api.models.event_info.EventInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    add_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_parameter = redrover_api.models.parameter_info.ParameterInfo(
                                                            attributes = 'None', 
                                                            member = redrover_api.models.member_info.MemberInfo(
                                                                member_type = 'Constructor', 
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, ), 
                                                            name = '0', 
                                                            parameter_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            position = 56, 
                                                            is_in = True, 
                                                            is_lcid = True, 
                                                            is_optional = True, 
                                                            is_out = True, 
                                                            is_retval = True, 
                                                            default_value = null, 
                                                            raw_default_value = null, 
                                                            has_default_value = True, 
                                                            metadata_token = 56, ), 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    remove_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    raise_method = redrover_api.models.method_info.MethodInfo(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        attributes = 'ReuseSlot', 
                                                        method_implementation_flags = 'Managed', 
                                                        calling_convention = 'Standard', 
                                                        is_abstract = True, 
                                                        is_constructor = True, 
                                                        is_final = True, 
                                                        is_hide_by_sig = True, 
                                                        is_special_name = True, 
                                                        is_static = True, 
                                                        is_virtual = True, 
                                                        is_assembly = True, 
                                                        is_family = True, 
                                                        is_family_and_assembly = True, 
                                                        is_family_or_assembly = True, 
                                                        is_private = True, 
                                                        is_public = True, 
                                                        is_constructed_generic_method = True, 
                                                        is_generic_method = True, 
                                                        is_generic_method_definition = True, 
                                                        contains_generic_parameters = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        member_type = 'Constructor', 
                                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                    is_multicast = True, 
                                                    event_handler_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), )
                                                ], 
                                            declared_fields = [
                                                redrover_api.models.field_info.FieldInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'PrivateScope', 
                                                    field_type = redrover_api.models.type.Type(
                                                        name = '0', 
                                                        is_collectible = True, 
                                                        metadata_token = 56, 
                                                        is_interface = True, 
                                                        member_type = 'Constructor', 
                                                        namespace = '0', 
                                                        assembly_qualified_name = '0', 
                                                        full_name = '0', 
                                                        is_nested = True, 
                                                        is_type_definition = True, 
                                                        is_array = True, 
                                                        is_by_ref = True, 
                                                        is_pointer = True, 
                                                        is_constructed_generic_type = True, 
                                                        is_generic_parameter = True, 
                                                        is_generic_type_parameter = True, 
                                                        is_generic_method_parameter = True, 
                                                        is_generic_type = True, 
                                                        is_generic_type_definition = True, 
                                                        is_sz_array = True, 
                                                        is_variable_bound_array = True, 
                                                        is_by_ref_like = True, 
                                                        has_element_type = True, 
                                                        generic_parameter_position = 56, 
                                                        generic_parameter_attributes = 'None', 
                                                        attributes = 'NotPublic', 
                                                        is_abstract = True, 
                                                        is_import = True, 
                                                        is_sealed = True, 
                                                        is_special_name = True, 
                                                        is_class = True, 
                                                        is_nested_assembly = True, 
                                                        is_nested_fam_and_assem = True, 
                                                        is_nested_family = True, 
                                                        is_nested_fam_or_assem = True, 
                                                        is_nested_private = True, 
                                                        is_nested_public = True, 
                                                        is_not_public = True, 
                                                        is_public = True, 
                                                        is_auto_layout = True, 
                                                        is_explicit_layout = True, 
                                                        is_layout_sequential = True, 
                                                        is_ansi_class = True, 
                                                        is_auto_class = True, 
                                                        is_unicode_class = True, 
                                                        is_com_object = True, 
                                                        is_contextful = True, 
                                                        is_enum = True, 
                                                        is_marshal_by_ref = True, 
                                                        is_primitive = True, 
                                                        is_value_type = True, 
                                                        is_signature_type = True, 
                                                        is_security_critical = True, 
                                                        is_security_safe_critical = True, 
                                                        is_security_transparent = True, 
                                                        guid = '0', 
                                                        is_serializable = True, 
                                                        contains_generic_parameters = True, 
                                                        is_visible = True, ), 
                                                    is_init_only = True, 
                                                    is_literal = True, 
                                                    is_not_serialized = True, 
                                                    is_pinvoke_impl = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    field_handle = redrover_api.models.runtime_field_handle.RuntimeFieldHandle(), )
                                                ], 
                                            declared_members = [
                                                redrover_api.models.member_info.MemberInfo(
                                                    member_type = 'Constructor', 
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, )
                                                ], 
                                            declared_methods = [
                                                redrover_api.models.method_info.MethodInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    attributes = 'ReuseSlot', 
                                                    method_implementation_flags = 'Managed', 
                                                    calling_convention = 'Standard', 
                                                    is_abstract = True, 
                                                    is_constructor = True, 
                                                    is_final = True, 
                                                    is_hide_by_sig = True, 
                                                    is_special_name = True, 
                                                    is_static = True, 
                                                    is_virtual = True, 
                                                    is_assembly = True, 
                                                    is_family = True, 
                                                    is_family_and_assembly = True, 
                                                    is_family_or_assembly = True, 
                                                    is_private = True, 
                                                    is_public = True, 
                                                    is_constructed_generic_method = True, 
                                                    is_generic_method = True, 
                                                    is_generic_method_definition = True, 
                                                    contains_generic_parameters = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    member_type = 'Constructor', 
                                                    return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), )
                                                ], 
                                            declared_nested_types = [
                                                redrover_api.models.type_info.TypeInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, 
                                                    declared_properties = [
                                                        redrover_api.models.property_info.PropertyInfo(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            member_type = 'Constructor', 
                                                            property_type = redrover_api.models.type.Type(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                is_interface = True, 
                                                                member_type = 'Constructor', 
                                                                namespace = '0', 
                                                                assembly_qualified_name = '0', 
                                                                full_name = '0', 
                                                                is_nested = True, 
                                                                is_type_definition = True, 
                                                                is_array = True, 
                                                                is_by_ref = True, 
                                                                is_pointer = True, 
                                                                is_constructed_generic_type = True, 
                                                                is_generic_parameter = True, 
                                                                is_generic_type_parameter = True, 
                                                                is_generic_method_parameter = True, 
                                                                is_generic_type = True, 
                                                                is_generic_type_definition = True, 
                                                                is_sz_array = True, 
                                                                is_variable_bound_array = True, 
                                                                is_by_ref_like = True, 
                                                                has_element_type = True, 
                                                                generic_parameter_position = 56, 
                                                                generic_parameter_attributes = 'None', 
                                                                attributes = 'NotPublic', 
                                                                is_abstract = True, 
                                                                is_import = True, 
                                                                is_sealed = True, 
                                                                is_special_name = True, 
                                                                is_class = True, 
                                                                is_nested_assembly = True, 
                                                                is_nested_fam_and_assem = True, 
                                                                is_nested_family = True, 
                                                                is_nested_fam_or_assem = True, 
                                                                is_nested_private = True, 
                                                                is_nested_public = True, 
                                                                is_not_public = True, 
                                                                is_public = True, 
                                                                is_auto_layout = True, 
                                                                is_explicit_layout = True, 
                                                                is_layout_sequential = True, 
                                                                is_ansi_class = True, 
                                                                is_auto_class = True, 
                                                                is_unicode_class = True, 
                                                                is_com_object = True, 
                                                                is_contextful = True, 
                                                                is_enum = True, 
                                                                is_marshal_by_ref = True, 
                                                                is_primitive = True, 
                                                                is_value_type = True, 
                                                                is_signature_type = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                guid = '0', 
                                                                is_serializable = True, 
                                                                contains_generic_parameters = True, 
                                                                is_visible = True, ), 
                                                            attributes = 'None', 
                                                            is_special_name = True, 
                                                            can_read = True, 
                                                            can_write = True, 
                                                            get_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                                            set_method = redrover_api.models.method_info.MethodInfo(
                                                                name = '0', 
                                                                is_collectible = True, 
                                                                metadata_token = 56, 
                                                                attributes = 'ReuseSlot', 
                                                                method_implementation_flags = 'Managed', 
                                                                calling_convention = 'Standard', 
                                                                is_abstract = True, 
                                                                is_constructor = True, 
                                                                is_final = True, 
                                                                is_hide_by_sig = True, 
                                                                is_special_name = True, 
                                                                is_static = True, 
                                                                is_virtual = True, 
                                                                is_assembly = True, 
                                                                is_family = True, 
                                                                is_family_and_assembly = True, 
                                                                is_family_or_assembly = True, 
                                                                is_private = True, 
                                                                is_public = True, 
                                                                is_constructed_generic_method = True, 
                                                                is_generic_method = True, 
                                                                is_generic_method_definition = True, 
                                                                contains_generic_parameters = True, 
                                                                is_security_critical = True, 
                                                                is_security_safe_critical = True, 
                                                                is_security_transparent = True, 
                                                                member_type = 'Constructor', 
                                                                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), )
                                                        ], 
                                                    implemented_interfaces = [
                                                        redrover_api.models.type.Type(
                                                            name = '0', 
                                                            is_collectible = True, 
                                                            metadata_token = 56, 
                                                            is_interface = True, 
                                                            member_type = 'Constructor', 
                                                            namespace = '0', 
                                                            assembly_qualified_name = '0', 
                                                            full_name = '0', 
                                                            is_nested = True, 
                                                            is_type_definition = True, 
                                                            is_array = True, 
                                                            is_by_ref = True, 
                                                            is_pointer = True, 
                                                            is_constructed_generic_type = True, 
                                                            is_generic_parameter = True, 
                                                            is_generic_type_parameter = True, 
                                                            is_generic_method_parameter = True, 
                                                            is_generic_type = True, 
                                                            is_generic_type_definition = True, 
                                                            is_sz_array = True, 
                                                            is_variable_bound_array = True, 
                                                            is_by_ref_like = True, 
                                                            has_element_type = True, 
                                                            generic_parameter_position = 56, 
                                                            generic_parameter_attributes = 'None', 
                                                            attributes = 'NotPublic', 
                                                            is_abstract = True, 
                                                            is_import = True, 
                                                            is_sealed = True, 
                                                            is_special_name = True, 
                                                            is_class = True, 
                                                            is_nested_assembly = True, 
                                                            is_nested_fam_and_assem = True, 
                                                            is_nested_family = True, 
                                                            is_nested_fam_or_assem = True, 
                                                            is_nested_private = True, 
                                                            is_nested_public = True, 
                                                            is_not_public = True, 
                                                            is_public = True, 
                                                            is_auto_layout = True, 
                                                            is_explicit_layout = True, 
                                                            is_layout_sequential = True, 
                                                            is_ansi_class = True, 
                                                            is_auto_class = True, 
                                                            is_unicode_class = True, 
                                                            is_com_object = True, 
                                                            is_contextful = True, 
                                                            is_enum = True, 
                                                            is_marshal_by_ref = True, 
                                                            is_primitive = True, 
                                                            is_value_type = True, 
                                                            is_signature_type = True, 
                                                            is_security_critical = True, 
                                                            is_security_safe_critical = True, 
                                                            is_security_transparent = True, 
                                                            guid = '0', 
                                                            is_serializable = True, 
                                                            contains_generic_parameters = True, 
                                                            is_visible = True, )
                                                        ], )
                                                ], 
                                            declared_properties = [
                                                redrover_api.models.property_info.PropertyInfo(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    member_type = 'Constructor', 
                                                    attributes = 'None', 
                                                    is_special_name = True, 
                                                    can_read = True, 
                                                    can_write = True, )
                                                ], 
                                            implemented_interfaces = [
                                                redrover_api.models.type.Type(
                                                    name = '0', 
                                                    is_collectible = True, 
                                                    metadata_token = 56, 
                                                    is_interface = True, 
                                                    member_type = 'Constructor', 
                                                    namespace = '0', 
                                                    assembly_qualified_name = '0', 
                                                    full_name = '0', 
                                                    is_nested = True, 
                                                    is_type_definition = True, 
                                                    is_array = True, 
                                                    is_by_ref = True, 
                                                    is_pointer = True, 
                                                    is_constructed_generic_type = True, 
                                                    is_generic_parameter = True, 
                                                    is_generic_type_parameter = True, 
                                                    is_generic_method_parameter = True, 
                                                    is_generic_type = True, 
                                                    is_generic_type_definition = True, 
                                                    is_sz_array = True, 
                                                    is_variable_bound_array = True, 
                                                    is_by_ref_like = True, 
                                                    has_element_type = True, 
                                                    generic_parameter_position = 56, 
                                                    generic_parameter_attributes = 'None', 
                                                    attributes = 'NotPublic', 
                                                    is_abstract = True, 
                                                    is_import = True, 
                                                    is_sealed = True, 
                                                    is_special_name = True, 
                                                    is_class = True, 
                                                    is_nested_assembly = True, 
                                                    is_nested_fam_and_assem = True, 
                                                    is_nested_family = True, 
                                                    is_nested_fam_or_assem = True, 
                                                    is_nested_private = True, 
                                                    is_nested_public = True, 
                                                    is_not_public = True, 
                                                    is_public = True, 
                                                    is_auto_layout = True, 
                                                    is_explicit_layout = True, 
                                                    is_layout_sequential = True, 
                                                    is_ansi_class = True, 
                                                    is_auto_class = True, 
                                                    is_unicode_class = True, 
                                                    is_com_object = True, 
                                                    is_contextful = True, 
                                                    is_enum = True, 
                                                    is_marshal_by_ref = True, 
                                                    is_primitive = True, 
                                                    is_value_type = True, 
                                                    is_signature_type = True, 
                                                    is_security_critical = True, 
                                                    is_security_safe_critical = True, 
                                                    is_security_transparent = True, 
                                                    guid = '0', 
                                                    is_serializable = True, 
                                                    contains_generic_parameters = True, 
                                                    is_visible = True, )
                                                ], )
                                        ], 
                                    exported_types = [
                                        redrover_api.models.type.Type(
                                            name = '0', 
                                            is_collectible = True, 
                                            metadata_token = 56, 
                                            is_interface = True, 
                                            member_type = 'Constructor', 
                                            namespace = '0', 
                                            assembly_qualified_name = '0', 
                                            full_name = '0', 
                                            is_nested = True, 
                                            is_type_definition = True, 
                                            is_array = True, 
                                            is_by_ref = True, 
                                            is_pointer = True, 
                                            is_constructed_generic_type = True, 
                                            is_generic_parameter = True, 
                                            is_generic_type_parameter = True, 
                                            is_generic_method_parameter = True, 
                                            is_generic_type = True, 
                                            is_generic_type_definition = True, 
                                            is_sz_array = True, 
                                            is_variable_bound_array = True, 
                                            is_by_ref_like = True, 
                                            has_element_type = True, 
                                            generic_parameter_position = 56, 
                                            generic_parameter_attributes = 'None', 
                                            attributes = 'NotPublic', 
                                            is_abstract = True, 
                                            is_import = True, 
                                            is_sealed = True, 
                                            is_special_name = True, 
                                            is_class = True, 
                                            is_nested_assembly = True, 
                                            is_nested_fam_and_assem = True, 
                                            is_nested_family = True, 
                                            is_nested_fam_or_assem = True, 
                                            is_nested_private = True, 
                                            is_nested_public = True, 
                                            is_not_public = True, 
                                            is_public = True, 
                                            is_auto_layout = True, 
                                            is_explicit_layout = True, 
                                            is_layout_sequential = True, 
                                            is_ansi_class = True, 
                                            is_auto_class = True, 
                                            is_unicode_class = True, 
                                            is_com_object = True, 
                                            is_contextful = True, 
                                            is_enum = True, 
                                            is_marshal_by_ref = True, 
                                            is_primitive = True, 
                                            is_value_type = True, 
                                            is_signature_type = True, 
                                            is_security_critical = True, 
                                            is_security_safe_critical = True, 
                                            is_security_transparent = True, 
                                            guid = '0', 
                                            is_serializable = True, 
                                            contains_generic_parameters = True, 
                                            is_visible = True, )
                                        ], 
                                    code_base = '0', 
                                    entry_point = redrover_api.models.method_info.MethodInfo(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        attributes = 'ReuseSlot', 
                                        method_implementation_flags = 'Managed', 
                                        calling_convention = 'Standard', 
                                        is_abstract = True, 
                                        is_constructor = True, 
                                        is_final = True, 
                                        is_hide_by_sig = True, 
                                        is_special_name = True, 
                                        is_static = True, 
                                        is_virtual = True, 
                                        is_assembly = True, 
                                        is_family = True, 
                                        is_family_and_assembly = True, 
                                        is_family_or_assembly = True, 
                                        is_private = True, 
                                        is_public = True, 
                                        is_constructed_generic_method = True, 
                                        is_generic_method = True, 
                                        is_generic_method_definition = True, 
                                        contains_generic_parameters = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        member_type = 'Constructor', 
                                        return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider(), ), 
                                    full_name = '0', 
                                    image_runtime_version = '0', 
                                    is_dynamic = True, 
                                    location = '0', 
                                    reflection_only = True, 
                                    is_collectible = True, 
                                    is_fully_trusted = True, 
                                    escaped_code_base = '0', 
                                    manifest_module = redrover_api.models.module.Module(
                                        fully_qualified_name = '0', 
                                        name = '0', 
                                        md_stream_version = 56, 
                                        module_version_id = '0', 
                                        scope_name = '0', 
                                        metadata_token = 56, ), 
                                    modules = [
                                        redrover_api.models.module.Module(
                                            fully_qualified_name = '0', 
                                            name = '0', 
                                            md_stream_version = 56, 
                                            module_version_id = '0', 
                                            scope_name = '0', 
                                            metadata_token = 56, )
                                        ], 
                                    global_assembly_cache = True, 
                                    host_context = 56, 
                                    security_rule_set = 'None', ), 
                                module = redrover_api.models.module.Module(
                                    fully_qualified_name = '0', 
                                    name = '0', 
                                    md_stream_version = 56, 
                                    module_version_id = '0', 
                                    scope_name = '0', 
                                    metadata_token = 56, ), 
                                is_nested = True, 
                                declaring_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                declaring_method = redrover_api.models.method_base.MethodBase(
                                    member_type = 'Constructor', 
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, ), 
                                reflected_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                underlying_system_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_type_definition = True, 
                                is_array = True, 
                                is_by_ref = True, 
                                is_pointer = True, 
                                is_constructed_generic_type = True, 
                                is_generic_parameter = True, 
                                is_generic_type_parameter = True, 
                                is_generic_method_parameter = True, 
                                is_generic_type = True, 
                                is_generic_type_definition = True, 
                                is_sz_array = True, 
                                is_variable_bound_array = True, 
                                is_by_ref_like = True, 
                                has_element_type = True, 
                                generic_type_arguments = [
                                    redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, )
                                    ], 
                                generic_parameter_position = 56, 
                                generic_parameter_attributes = 'None', 
                                attributes = 'NotPublic', 
                                is_abstract = True, 
                                is_import = True, 
                                is_sealed = True, 
                                is_special_name = True, 
                                is_class = True, 
                                is_nested_assembly = True, 
                                is_nested_fam_and_assem = True, 
                                is_nested_family = True, 
                                is_nested_fam_or_assem = True, 
                                is_nested_private = True, 
                                is_nested_public = True, 
                                is_not_public = True, 
                                is_public = True, 
                                is_auto_layout = True, 
                                is_explicit_layout = True, 
                                is_layout_sequential = True, 
                                is_ansi_class = True, 
                                is_auto_class = True, 
                                is_unicode_class = True, 
                                is_com_object = True, 
                                is_contextful = True, 
                                is_enum = True, 
                                is_marshal_by_ref = True, 
                                is_primitive = True, 
                                is_value_type = True, 
                                is_signature_type = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                                    type_id = null, ), 
                                type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    attributes = 'ReuseSlot', 
                                    method_implementation_flags = 'Managed', 
                                    calling_convention = 'Standard', 
                                    is_abstract = True, 
                                    is_constructor = True, 
                                    is_final = True, 
                                    is_hide_by_sig = True, 
                                    is_special_name = True, 
                                    is_static = True, 
                                    is_virtual = True, 
                                    is_assembly = True, 
                                    is_family = True, 
                                    is_family_and_assembly = True, 
                                    is_family_or_assembly = True, 
                                    is_private = True, 
                                    is_public = True, 
                                    is_constructed_generic_method = True, 
                                    is_generic_method = True, 
                                    is_generic_method_definition = True, 
                                    contains_generic_parameters = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    member_type = 'Constructor', ), 
                                type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                                guid = '0', 
                                base_type = redrover_api.models.type.Type(
                                    name = '0', 
                                    is_collectible = True, 
                                    metadata_token = 56, 
                                    is_interface = True, 
                                    member_type = 'Constructor', 
                                    namespace = '0', 
                                    assembly_qualified_name = '0', 
                                    full_name = '0', 
                                    is_nested = True, 
                                    is_type_definition = True, 
                                    is_array = True, 
                                    is_by_ref = True, 
                                    is_pointer = True, 
                                    is_constructed_generic_type = True, 
                                    is_generic_parameter = True, 
                                    is_generic_type_parameter = True, 
                                    is_generic_method_parameter = True, 
                                    is_generic_type = True, 
                                    is_generic_type_definition = True, 
                                    is_sz_array = True, 
                                    is_variable_bound_array = True, 
                                    is_by_ref_like = True, 
                                    has_element_type = True, 
                                    generic_parameter_position = 56, 
                                    generic_parameter_attributes = 'None', 
                                    attributes = 'NotPublic', 
                                    is_abstract = True, 
                                    is_import = True, 
                                    is_sealed = True, 
                                    is_special_name = True, 
                                    is_class = True, 
                                    is_nested_assembly = True, 
                                    is_nested_fam_and_assem = True, 
                                    is_nested_family = True, 
                                    is_nested_fam_or_assem = True, 
                                    is_nested_private = True, 
                                    is_nested_public = True, 
                                    is_not_public = True, 
                                    is_public = True, 
                                    is_auto_layout = True, 
                                    is_explicit_layout = True, 
                                    is_layout_sequential = True, 
                                    is_ansi_class = True, 
                                    is_auto_class = True, 
                                    is_unicode_class = True, 
                                    is_com_object = True, 
                                    is_contextful = True, 
                                    is_enum = True, 
                                    is_marshal_by_ref = True, 
                                    is_primitive = True, 
                                    is_value_type = True, 
                                    is_signature_type = True, 
                                    is_security_critical = True, 
                                    is_security_safe_critical = True, 
                                    is_security_transparent = True, 
                                    guid = '0', 
                                    is_serializable = True, 
                                    contains_generic_parameters = True, 
                                    is_visible = True, ), 
                                is_serializable = True, 
                                contains_generic_parameters = True, 
                                is_visible = True, ), 
                            constructor = redrover_api.models.constructor_info.ConstructorInfo(
                                name = '0', 
                                is_collectible = True, 
                                metadata_token = 56, 
                                attributes = 'ReuseSlot', 
                                method_implementation_flags = 'Managed', 
                                calling_convention = 'Standard', 
                                is_abstract = True, 
                                is_constructor = True, 
                                is_final = True, 
                                is_hide_by_sig = True, 
                                is_special_name = True, 
                                is_static = True, 
                                is_virtual = True, 
                                is_assembly = True, 
                                is_family = True, 
                                is_family_and_assembly = True, 
                                is_family_or_assembly = True, 
                                is_private = True, 
                                is_public = True, 
                                is_constructed_generic_method = True, 
                                is_generic_method = True, 
                                is_generic_method_definition = True, 
                                contains_generic_parameters = True, 
                                is_security_critical = True, 
                                is_security_safe_critical = True, 
                                is_security_transparent = True, 
                                member_type = 'Constructor', ), 
                            constructor_arguments = [
                                redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(
                                    argument_type = redrover_api.models.type.Type(
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, 
                                        is_interface = True, 
                                        member_type = 'Constructor', 
                                        namespace = '0', 
                                        assembly_qualified_name = '0', 
                                        full_name = '0', 
                                        is_nested = True, 
                                        is_type_definition = True, 
                                        is_array = True, 
                                        is_by_ref = True, 
                                        is_pointer = True, 
                                        is_constructed_generic_type = True, 
                                        is_generic_parameter = True, 
                                        is_generic_type_parameter = True, 
                                        is_generic_method_parameter = True, 
                                        is_generic_type = True, 
                                        is_generic_type_definition = True, 
                                        is_sz_array = True, 
                                        is_variable_bound_array = True, 
                                        is_by_ref_like = True, 
                                        has_element_type = True, 
                                        generic_parameter_position = 56, 
                                        generic_parameter_attributes = 'None', 
                                        attributes = 'NotPublic', 
                                        is_abstract = True, 
                                        is_import = True, 
                                        is_sealed = True, 
                                        is_special_name = True, 
                                        is_class = True, 
                                        is_nested_assembly = True, 
                                        is_nested_fam_and_assem = True, 
                                        is_nested_family = True, 
                                        is_nested_fam_or_assem = True, 
                                        is_nested_private = True, 
                                        is_nested_public = True, 
                                        is_not_public = True, 
                                        is_public = True, 
                                        is_auto_layout = True, 
                                        is_explicit_layout = True, 
                                        is_layout_sequential = True, 
                                        is_ansi_class = True, 
                                        is_auto_class = True, 
                                        is_unicode_class = True, 
                                        is_com_object = True, 
                                        is_contextful = True, 
                                        is_enum = True, 
                                        is_marshal_by_ref = True, 
                                        is_primitive = True, 
                                        is_value_type = True, 
                                        is_signature_type = True, 
                                        is_security_critical = True, 
                                        is_security_safe_critical = True, 
                                        is_security_transparent = True, 
                                        guid = '0', 
                                        is_serializable = True, 
                                        contains_generic_parameters = True, 
                                        is_visible = True, ), )
                                ], 
                            named_arguments = [
                                redrover_api.models.custom_attribute_named_argument.CustomAttributeNamedArgument(
                                    member_info = redrover_api.models.member_info.MemberInfo(
                                        member_type = 'Constructor', 
                                        name = '0', 
                                        is_collectible = True, 
                                        metadata_token = 56, ), 
                                    typed_value = redrover_api.models.custom_attribute_typed_argument.CustomAttributeTypedArgument(), 
                                    member_name = '0', 
                                    is_field = True, )
                                ], )
                        ], 
                    is_collectible = True, 
                    metadata_token = 56, 
                    is_interface = True, 
                    member_type = 'Constructor', 
                    namespace = '0', 
                    assembly_qualified_name = '0', 
                    full_name = '0', 
                    assembly = redrover_api.models.assembly.Assembly(
                        code_base = '0', 
                        full_name = '0', 
                        image_runtime_version = '0', 
                        is_dynamic = True, 
                        location = '0', 
                        reflection_only = True, 
                        is_collectible = True, 
                        is_fully_trusted = True, 
                        escaped_code_base = '0', 
                        global_assembly_cache = True, 
                        host_context = 56, 
                        security_rule_set = 'None', ), 
                    module = redrover_api.models.module.Module(
                        fully_qualified_name = '0', 
                        name = '0', 
                        md_stream_version = 56, 
                        module_version_id = '0', 
                        scope_name = '0', 
                        metadata_token = 56, ), 
                    is_nested = True, 
                    declaring_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    declaring_method = redrover_api.models.method_base.MethodBase(
                        member_type = 'Constructor', 
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, ), 
                    reflected_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    underlying_system_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_type_definition = True, 
                    is_array = True, 
                    is_by_ref = True, 
                    is_pointer = True, 
                    is_constructed_generic_type = True, 
                    is_generic_parameter = True, 
                    is_generic_type_parameter = True, 
                    is_generic_method_parameter = True, 
                    is_generic_type = True, 
                    is_generic_type_definition = True, 
                    is_sz_array = True, 
                    is_variable_bound_array = True, 
                    is_by_ref_like = True, 
                    has_element_type = True, 
                    generic_type_arguments = [
                        redrover_api.models.type.Type(
                            name = '0', 
                            is_collectible = True, 
                            metadata_token = 56, 
                            is_interface = True, 
                            member_type = 'Constructor', 
                            namespace = '0', 
                            assembly_qualified_name = '0', 
                            full_name = '0', 
                            is_nested = True, 
                            is_type_definition = True, 
                            is_array = True, 
                            is_by_ref = True, 
                            is_pointer = True, 
                            is_constructed_generic_type = True, 
                            is_generic_parameter = True, 
                            is_generic_type_parameter = True, 
                            is_generic_method_parameter = True, 
                            is_generic_type = True, 
                            is_generic_type_definition = True, 
                            is_sz_array = True, 
                            is_variable_bound_array = True, 
                            is_by_ref_like = True, 
                            has_element_type = True, 
                            generic_parameter_position = 56, 
                            generic_parameter_attributes = 'None', 
                            attributes = 'NotPublic', 
                            is_abstract = True, 
                            is_import = True, 
                            is_sealed = True, 
                            is_special_name = True, 
                            is_class = True, 
                            is_nested_assembly = True, 
                            is_nested_fam_and_assem = True, 
                            is_nested_family = True, 
                            is_nested_fam_or_assem = True, 
                            is_nested_private = True, 
                            is_nested_public = True, 
                            is_not_public = True, 
                            is_public = True, 
                            is_auto_layout = True, 
                            is_explicit_layout = True, 
                            is_layout_sequential = True, 
                            is_ansi_class = True, 
                            is_auto_class = True, 
                            is_unicode_class = True, 
                            is_com_object = True, 
                            is_contextful = True, 
                            is_enum = True, 
                            is_marshal_by_ref = True, 
                            is_primitive = True, 
                            is_value_type = True, 
                            is_signature_type = True, 
                            is_security_critical = True, 
                            is_security_safe_critical = True, 
                            is_security_transparent = True, 
                            guid = '0', 
                            is_serializable = True, 
                            contains_generic_parameters = True, 
                            is_visible = True, )
                        ], 
                    generic_parameter_position = 56, 
                    generic_parameter_attributes = 'None', 
                    attributes = 'NotPublic', 
                    is_abstract = True, 
                    is_import = True, 
                    is_sealed = True, 
                    is_special_name = True, 
                    is_class = True, 
                    is_nested_assembly = True, 
                    is_nested_fam_and_assem = True, 
                    is_nested_family = True, 
                    is_nested_fam_or_assem = True, 
                    is_nested_private = True, 
                    is_nested_public = True, 
                    is_not_public = True, 
                    is_public = True, 
                    is_auto_layout = True, 
                    is_explicit_layout = True, 
                    is_layout_sequential = True, 
                    is_ansi_class = True, 
                    is_auto_class = True, 
                    is_unicode_class = True, 
                    is_com_object = True, 
                    is_contextful = True, 
                    is_enum = True, 
                    is_marshal_by_ref = True, 
                    is_primitive = True, 
                    is_value_type = True, 
                    is_signature_type = True, 
                    is_security_critical = True, 
                    is_security_safe_critical = True, 
                    is_security_transparent = True, 
                    struct_layout_attribute = redrover_api.models.struct_layout_attribute.StructLayoutAttribute(
                        type_id = null, ), 
                    type_initializer = redrover_api.models.constructor_info.ConstructorInfo(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        attributes = 'ReuseSlot', 
                        method_implementation_flags = 'Managed', 
                        calling_convention = 'Standard', 
                        is_abstract = True, 
                        is_constructor = True, 
                        is_final = True, 
                        is_hide_by_sig = True, 
                        is_special_name = True, 
                        is_static = True, 
                        is_virtual = True, 
                        is_assembly = True, 
                        is_family = True, 
                        is_family_and_assembly = True, 
                        is_family_or_assembly = True, 
                        is_private = True, 
                        is_public = True, 
                        is_constructed_generic_method = True, 
                        is_generic_method = True, 
                        is_generic_method_definition = True, 
                        contains_generic_parameters = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        member_type = 'Constructor', ), 
                    type_handle = redrover_api.models.runtime_type_handle.RuntimeTypeHandle(), 
                    guid = '0', 
                    base_type = redrover_api.models.type.Type(
                        name = '0', 
                        is_collectible = True, 
                        metadata_token = 56, 
                        is_interface = True, 
                        member_type = 'Constructor', 
                        namespace = '0', 
                        assembly_qualified_name = '0', 
                        full_name = '0', 
                        is_nested = True, 
                        is_type_definition = True, 
                        is_array = True, 
                        is_by_ref = True, 
                        is_pointer = True, 
                        is_constructed_generic_type = True, 
                        is_generic_parameter = True, 
                        is_generic_type_parameter = True, 
                        is_generic_method_parameter = True, 
                        is_generic_type = True, 
                        is_generic_type_definition = True, 
                        is_sz_array = True, 
                        is_variable_bound_array = True, 
                        is_by_ref_like = True, 
                        has_element_type = True, 
                        generic_parameter_position = 56, 
                        generic_parameter_attributes = 'None', 
                        attributes = 'NotPublic', 
                        is_abstract = True, 
                        is_import = True, 
                        is_sealed = True, 
                        is_special_name = True, 
                        is_class = True, 
                        is_nested_assembly = True, 
                        is_nested_fam_and_assem = True, 
                        is_nested_family = True, 
                        is_nested_fam_or_assem = True, 
                        is_nested_private = True, 
                        is_nested_public = True, 
                        is_not_public = True, 
                        is_public = True, 
                        is_auto_layout = True, 
                        is_explicit_layout = True, 
                        is_layout_sequential = True, 
                        is_ansi_class = True, 
                        is_auto_class = True, 
                        is_unicode_class = True, 
                        is_com_object = True, 
                        is_contextful = True, 
                        is_enum = True, 
                        is_marshal_by_ref = True, 
                        is_primitive = True, 
                        is_value_type = True, 
                        is_signature_type = True, 
                        is_security_critical = True, 
                        is_security_safe_critical = True, 
                        is_security_transparent = True, 
                        guid = '0', 
                        is_serializable = True, 
                        contains_generic_parameters = True, 
                        is_visible = True, ), 
                    is_serializable = True, 
                    contains_generic_parameters = True, 
                    is_visible = True, ), 
                return_type_custom_attributes = redrover_api.models.i_custom_attribute_provider.ICustomAttributeProvider()
            )
        else :
            return MethodInfo(
        )

    def testMethodInfo(self):
        """Test MethodInfo"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
